//Program to create inital pool of variants in a crossing experiment


#include <iostream>
#include <sstream>
#include <vector>
#include <list>
#include <deque>

using namespace std;
#include "crossing-tools.h"


int main(int argc, char *argv[]){
	
	
	if(argc != 8){
		cout<< "Usage ./run_crossing N n_loci dist_between_loci rho Ngen Nsample seed" <<endl;
		exit(0);
	}
	
	int N=(int)atof(argv[1]); /* how large population */
	int n_loci=atoi(argv[2]); /* how many segregating sites */
	int dist=atoi(argv[3]); /* distance between segregating sites */
	double rho=atof(argv[4]); /* base rate of recombination per generation per basepair */
	int Ngen=atoi(argv[5]); /* number of generations of crossing */
	int Nsample=atoi(argv[6]);  /* number of haplotypes sampled from the final pool */
	int seed=atoi(argv[7]); /* seed for random number generator */

	gsl_rng_env_setup();
	srand((unsigned int)(seed)); 
	
	gsl_rng *rgen = gsl_rng_alloc (gsl_rng_taus);
	gsl_rng_set (rgen, seed);
	
	vector < std::string > population;
	vector < std::string  > populationNew;

	init_population(population,N,n_loci);
	populationNew=population;
	
	double nlRho=(double)N*(double)dist*(double)n_loci*rho;
	vector <double> nlRhoV(n_loci-1);
	for(int i=0; i< nlRhoV.size(); i++){
		nlRhoV[i]=nlRho/(double)n_loci;
	}
		
	for(int iC=0; iC< Ngen; iC++){
		combined_resample_cross_rhoV(population, populationNew, nlRhoV, rgen);
		population=populationNew;				
	}
	print_population_sample(Nsample, population);
	
	return EXIT_SUCCESS;
}







							
					
 
							
	
