//Functions for crossroad program to create calculate likelihood surface for large "infinite" and finite populations in a crossing experiment.
#include <iostream>
#include <sstream>
#include <vector>
#include <list>
#include <deque>
#include <iostream>
#include <iomanip>
#include <fstream>
#include <cstring>
#include <vector>
#include <string>
#include <algorithm>


#include <math.h>
#include <map>
#include <gsl/gsl_rng.h>
#include <gsl/gsl_randist.h>

#include "utilities.h"
using namespace std;


/* output routine to print format which LDhat can import */

void print_header(int N, int Npairs, int Ngrid, vector < double> &rho){
	
	cout << N <<"\t" << Npairs <<"\n";
	cout << "1\t" << "0.0" << "\n";
	cout << Ngrid <<"\t" << rho.back() << "\n";
	cout <<"\n\n";
	
	cout << "type\t00\t01\t10\t11\tRho\t";
	
	for(int i=0; i<rho.size(); i++){
		cout << rho[i] <<"\t";
	}
	cout <<"\n\n";
}

/* output routine to print format which LDhat can import */

void print_line(int number, vector <int> &Nv, vector < double> &ll){
	
	cout << number << "\t#\t";
	
	for(int i=0; i<Nv.size(); i++){
		cout << Nv[i] <<"\t";
	}
	cout << ":\t";
	
	for(int i=0; i<ll.size(); i++){
		cout << ll[i] <<"\t";
	}
	cout <<"\n";
	

}

/* probability of observing counts Nv given a true frequency vector q */

double log_likehood(vector <int> &Nv, vector < double> &q){
	
	double p[Nv.size()];
	unsigned int n[Nv.size()];
	
	for(int i=0; i<Nv.size(); i++){
		p[i]=q[i];
		n[i]=Nv[i];
	}
	double ll=gsl_ran_multinomial_lnpdf (Nv.size(),p,n);
	return ll;
}



/* a table of all possible two locus haplotype observations having samples Nsample haplotypes */

void create_pairs(int Nsample, vector < observation > &table){

			
	for(int i1=0; i1<Nsample; i1++){
		for(int i2=0; i2<Nsample; i2++){
			for(int i3=0; i3<Nsample; i3++){
				int i4=Nsample-i1-i2-i3;
				
				if(i4>=0){
					observation obs;
					obs.draw.push_back(i1);
					obs.draw.push_back(i2);
					obs.draw.push_back(i3);
					obs.draw.push_back(i4);
					table.push_back(obs);		
				}
				
			}
		}
	}
}






							
					
 
							
	