(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    214410,       5632]
NotebookOptionsPosition[    211992,       5551]
NotebookOutlinePosition[    212382,       5568]
CellTagsIndexPosition[    212339,       5565]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Data", "Section",
 CellChangeTimes->{{3.536834242545212*^9, 3.536834243174358*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
  "SetDirectory", "[", 
   "\"\</Users/vm5/work/projects/tools/crossroad_package/mathematica/\>\"", 
   "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.537448640721369*^9, 3.537448662376774*^9}, {
  3.537449271771468*^9, 3.5374492949227037`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"dirres", "=", "\"\<../inference_results/\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.537510968055683*^9, 3.537511010419709*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"dirdata", "=", "\"\<../simulation_data/\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.537511005568123*^9, 3.537511020919675*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"rhoProfile", "=", 
   RowBox[{"Import", "[", 
    RowBox[{
     RowBox[{
     "dirdata", "<>", "\"\<rhoV.L100.d1kb.rho5.0e-6.U.txt.N1.0e5.9730\>\""}], 
     ",", "\"\<Table\>\""}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rhoV", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"i", "-", "1"}], ",", 
       RowBox[{
        RowBox[{"rhoProfile", "[", 
         RowBox[{"[", "i", "]"}], "]"}], "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", 
       RowBox[{"Length", "[", "rhoProfile", "]"}]}], "}"}]}], "]"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.536834657993677*^9, 3.536834702042523*^9}, {
  3.53683575435824*^9, 3.5368357544609528`*^9}, {3.53683591672134*^9, 
  3.5368359173602247`*^9}, {3.5368378840289927`*^9, 3.536837886336974*^9}, {
  3.5375110473725433`*^9, 3.5375110476923237`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"inputFilesN5", "=", 
   RowBox[{"Import", "[", 
    RowBox[{"\"\<file.list.N1.0e5.txt\>\"", ",", "\"\<Table\>\""}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"inputFilesN4", "=", 
   RowBox[{"Import", "[", 
    RowBox[{"\"\<file.list.N1.0e4.txt\>\"", ",", "\"\<Table\>\""}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"inputFilesN3", "=", 
   RowBox[{"Import", "[", 
    RowBox[{"\"\<file.list.N1.0e3.txt\>\"", ",", "\"\<Table\>\""}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"inputFilesN2", "=", 
   RowBox[{"Import", "[", 
    RowBox[{"\"\<file.list.N1.0e2.txt\>\"", ",", "\"\<Table\>\""}], "]"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.536850421517776*^9, 3.5368504654914303`*^9}, 
   3.536853996046146*^9, {3.537278307809374*^9, 3.53727830835524*^9}, {
   3.537442146177681*^9, 3.5374421525235233`*^9}, 3.537511071145496*^9, 
   3.537514900487898*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Tools", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.53683425371879*^9, 3.536834255038649*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"options", "[", 
     RowBox[{"xlabel_", ",", "ylabel_", ",", "title_"}], "]"}], ":=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Frame", "->", "True"}], ",", 
      RowBox[{"AspectRatio", "->", 
       RowBox[{"1", "/", "GoldenRatio"}]}], ",", 
      RowBox[{"Frame", " ", "->", " ", "True"}], ",", " ", 
      RowBox[{"Axes", "->", "False"}], ",", "\n", "\t", 
      RowBox[{"FrameStyle", " ", "->", " ", 
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"Thickness", "[", "0.004", "]"}], ",", " ", 
         RowBox[{"FontSize", " ", "->", " ", "18"}]}], "]"}]}], ",", " ", 
      "\n", "\t", 
      RowBox[{"FrameLabel", " ", "->", " ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"ylabel", ",", " ", "None"}], "}"}], ",", " ", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Text", "[", " ", 
            RowBox[{"Style", "[", "xlabel", "]"}], "]"}], ",", 
           RowBox[{"Text", "[", " ", 
            RowBox[{"Style", "[", "title", "]"}], "]"}]}], "}"}]}], "}"}]}]}],
      "}"}]}], ";"}], "\n"}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"plotRhoLog", "[", 
   RowBox[{"tag1_", ",", "colour_", ",", "window_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "rho1", ",", "rho1Up", ",", "rho1L", ",", "rho1s", ",", "rho1Ups", ",", 
      "rho1Ls", ",", "f1", ",", "out", ",", "cc"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"rho1", "=", 
      RowBox[{
       RowBox[{"Import", "[", 
        RowBox[{
         RowBox[{"dirres", "<>", "tag1"}], ",", "\"\<Table\>\""}], "]"}], "[", 
       RowBox[{"[", 
        RowBox[{
         RowBox[{"3", ";;", "All"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "3"}], "}"}]}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"rho1Up", "=", 
      RowBox[{
       RowBox[{"Import", "[", 
        RowBox[{
         RowBox[{"dirres", "<>", "tag1"}], ",", "\"\<Table\>\""}], "]"}], "[", 
       RowBox[{"[", 
        RowBox[{
         RowBox[{"3", ";;", "All"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "5"}], "}"}]}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"rho1L", "=", 
      RowBox[{
       RowBox[{"Import", "[", 
        RowBox[{
         RowBox[{"dirres", "<>", "tag1"}], ",", "\"\<Table\>\""}], "]"}], "[", 
       RowBox[{"[", 
        RowBox[{
         RowBox[{"3", ";;", "All"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "4"}], "}"}]}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"rho1s", "=", 
      RowBox[{"MovingAverage", "[", 
       RowBox[{"rho1", ",", "window"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"rho1Ups", "=", 
      RowBox[{"MovingAverage", "[", 
       RowBox[{"rho1Up", ",", "window"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"rho1Ls", "=", 
      RowBox[{"MovingAverage", "[", 
       RowBox[{"rho1L", ",", "window"}], "]"}]}], ";", "\[IndentingNewLine]", 
     
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"f1", "=", 
        RowBox[{"ListLogPlot", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"rho1s", ",", "rho1Ups", ",", "rho1Ls"}], "}"}], ",", 
          RowBox[{"Joined", "\[Rule]", "True"}], ",", 
          RowBox[{"PlotRange", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"All", ",", 
             RowBox[{"{", 
              RowBox[{"0.001", ",", "0.1"}], "}"}]}], "}"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"PlotStyle", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Directive", "[", 
              RowBox[{"colour", ",", "Thick"}], "]"}], ",", 
             RowBox[{"Directive", "[", 
              RowBox[{"colour", ",", "Dashed"}], "]"}], ",", 
             RowBox[{"Directive", "[", 
              RowBox[{"colour", ",", "Dashed"}], "]"}]}], "}"}]}]}], "]"}]}], 
       ";"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"f1", "=", 
      RowBox[{"ListLogPlot", "[", 
       RowBox[{
        RowBox[{"{", "rho1s", "}"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotRange", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"All", ",", 
           RowBox[{"{", 
            RowBox[{"0.001", ",", "0.5"}], "}"}]}], "}"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Directive", "[", 
           RowBox[{"colour", ",", "Thick"}], "]"}], "}"}]}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"out", "=", 
      RowBox[{"Show", "[", 
       RowBox[{"f1", ",", 
        RowBox[{"options", "[", 
         RowBox[{
         "\"\<locus kb\>\"", ",", "\"\<\[Rho] / kb\>\"", ",", "\"\<\>\""}], 
         "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Return", "[", "out", "]"}], ";"}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5368349424594717`*^9, 3.536834948022345*^9}, {
  3.536834978868094*^9, 3.536835009811399*^9}, {3.53683539407019*^9, 
  3.536835425293439*^9}, {3.536835465661833*^9, 3.536835482892579*^9}, {
  3.536835775060163*^9, 3.536835775729012*^9}, {3.536835811947733*^9, 
  3.536835812825375*^9}, {3.5368358977044067`*^9, 3.536835901021015*^9}, {
  3.536835945830564*^9, 3.5368359474368753`*^9}, {3.536835983230941*^9, 
  3.536835983916642*^9}, {3.536837804490409*^9, 3.536837835898054*^9}, {
  3.537511121623827*^9, 3.537511146532724*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"loadRho", "[", "file_", "]"}], ":=", 
   RowBox[{
    RowBox[{"Import", "[", 
     RowBox[{"file", ",", "\"\<Table\>\""}], "]"}], "[", 
    RowBox[{"[", 
     RowBox[{
      RowBox[{"3", ";;", "All"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "3"}], "}"}]}], "]"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Plots", "Section",
 CellChangeTimes->{{3.536834265822359*^9, 3.536834266541704*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"recHS", "=", 
  RowBox[{"Show", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"plotRhoLog", "[", 
       RowBox[{
       "\"\<res.txt.popHS.L100.d1kb.rho5.0e-6.U.txt.N1.0e5.9730\>\"", ",", 
        "Red", ",", "1"}], "]"}], ",", 
      RowBox[{"ListLogPlot", "[", 
       RowBox[{"rhoV", ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"Directive", "[", 
          RowBox[{"Blue", ",", "Thick"}], "]"}]}]}], "]"}]}], "}"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "400"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.536834508607896*^9, 3.53683451679875*^9}, {
  3.5368348890918293`*^9, 3.5368348998657293`*^9}, {3.536834953704328*^9, 
  3.536834956207782*^9}, {3.536835014606226*^9, 3.53683502094167*^9}, {
  3.536835096620893*^9, 3.53683517486333*^9}, {3.536835210049226*^9, 
  3.536835369155986*^9}, {3.536835417345769*^9, 3.536835417615333*^9}, {
  3.5368354901893797`*^9, 3.536835523956231*^9}, {3.536836089628113*^9, 
  3.536836105911682*^9}, {3.536836245117738*^9, 3.5368362513470592`*^9}, {
  3.536837781285392*^9, 3.536837785911256*^9}}],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    {RGBColor[1, 0, 0], Thickness[Large], LineBox[CompressedData["
1:eJxd0zsvw1EYx/GHiBhIGpq0giipEpG6Vt176lp36m4wVAwMNegLOInJYDIY
mtgMDF5AI+nRSCUd7SajSDAQiQGp/qXf4eTJJ9/8xlMX2Q/vFIrI9s/7vV8X
r/ezkYXA+Hv6xHFjN3vXsRNn0Ytl31ZisrRQVL5LLFe1PriLC2ywHXbC1ZaP
T6Plh+KC62E37IGb4Ga4BfZavpv2HwWlTTkrYpnnVM7tqqHM25jyOf7coRyh
q7PG3pw74S7YB3fDfrgH7oX7VMzz1Ba//Exm3Q8PwIPwEByw/Hgev3WJyreG
JYgOyzA6LCPosIyiwzKGDss4OiwT6LCE0GGZVDWJTG0oajfZDssUOizT6LDM
oMMyiw7LHDos8+j/fvv5/TZZyLeCNWxgWcQe1rCBJYw9rGEDy5La3UxXHmx8
JLN7WMMGlmXsYQ0bWFawhzVsYFnFHtawgWUNe1jDBpZ17GH9729XRstX
      "]]}}, {{}, 
    {RGBColor[0, 0, 1], Thickness[Large], PointBox[CompressedData["
1:eJxd0bsuhEEch+F/VEoFiYQCERGRjXVep/2s85ldp5qo9aq5CKV7MXdEpVAI
shGZZ5LJ5MmbXzWjd4/th56IuP+5v+/f6bw8Dz3VB3JX783SUZXuxX24Hw/i
YTyCx/A4nsCTeApP4xqewXU8i+fwPF7Ai3gJL+MGXqneGp9frdrHa9ereA2v
4w3cxFXphGOTjqNFx7FFx7FNx7FDx7FLx7FHx7FPx3FQ/kfCcUjHcUTHcUzH
cULHcUrHcUbHcV66wglnHBfsccIZR5s9Tjjj6JT/VeGEM45L9jjhjOOKPU44
47hmjxPOOG7Y44Qzjlv2OP37G5qV44o=
      "]]}, {}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->False,
  AxesOrigin->{0.001, -6.907755278982137},
  CoordinatesToolOptions:>{"DisplayFunction" -> ({
      Part[#, 1], 
      Exp[
       Part[#, 2]]}& ), "CopiedValueFunction" -> ({
      Part[#, 1], 
      Exp[
       Part[#, 2]]}& )},
  Frame->True,
  FrameLabel->{{
     FormBox["\"\[Rho] / kb\"", TraditionalForm], None}, {
     FormBox[
      InterpretationBox[
       Cell[
        BoxData[
         FormBox[
          StyleBox["\"locus kb\"", StripOnInput -> False], TraditionalForm]], 
        "Text", "TR"], 
       Text[
        Style["locus kb"]]], TraditionalForm], 
     FormBox[
      InterpretationBox[
       Cell[
        BoxData[
         FormBox[
          StyleBox["\"\"", StripOnInput -> False], TraditionalForm]], "Text", 
        "TR"], 
       Text[
        Style[""]]], TraditionalForm]}},
  FrameStyle->Directive[
    Thickness[0.004], FontSize -> 18],
  FrameTicks->{{{{-6.907755278982137, 
       FormBox[
        TagBox[
         InterpretationBox["\"0.001\"", 0.001, AutoDelete -> True], 
         NumberForm[#, {
           DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {-5.298317366548036, 
       FormBox[
        TagBox[
         InterpretationBox["\"0.005\"", 0.005, AutoDelete -> True], 
         NumberForm[#, {
           DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {-4.605170185988092, 
       FormBox[
        TagBox[
         InterpretationBox["\"0.010\"", 0.01, AutoDelete -> True], 
         NumberForm[#, {
           DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {-2.995732273553991, 
       FormBox[
        TagBox[
         InterpretationBox["\"0.050\"", 0.05, AutoDelete -> True], 
         NumberForm[#, {
           DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {-2.302585092994046, 
       FormBox[
        TagBox[
         InterpretationBox["\"0.100\"", 0.1, AutoDelete -> True], 
         NumberForm[#, {
           DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {-0.6931471805599453, 
       FormBox[
        TagBox[
         InterpretationBox["\"0.500\"", 0.5, AutoDelete -> True], 
         NumberForm[#, {
           DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {0., 
       FormBox[
        TagBox[
         InterpretationBox["\"1.000\"", 1., AutoDelete -> True], 
         NumberForm[#, {
           DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {1.6094379124341003`, 
       FormBox[
        TagBox[
         InterpretationBox["\"5.000\"", 5., AutoDelete -> True], 
         NumberForm[#, {
           DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {-6.214608098422191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-5.809142990314028, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-5.521460917862246, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-5.115995809754082, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-4.961845129926823, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-4.8283137373023015`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-4.710530701645918, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-3.912023005428146, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-3.506557897319982, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-3.2188758248682006`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-2.8134107167600364`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-2.6592600369327783`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-2.5257286443082556`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-2.4079456086518722`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-1.6094379124341003`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-1.203972804325936, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-0.916290731874155, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-0.5108256237659907, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-0.35667494393873245`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-0.2231435513142097, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-0.10536051565782628`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {0.6931471805599453, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {1.0986122886681098`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {1.3862943611198906`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}}, {{-6.907755278982137, 
       FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
       FormBox["\"\"", TraditionalForm]}, {-4.605170185988092, 
       FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
       FormBox["\"\"", TraditionalForm]}, {-2.302585092994046, 
       FormBox["\"\"", TraditionalForm]}, {-0.6931471805599453, 
       FormBox["\"\"", TraditionalForm]}, {0., 
       FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
       FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-5.809142990314028, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-5.521460917862246, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-5.115995809754082, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-4.961845129926823, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-4.8283137373023015`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-4.710530701645918, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-3.912023005428146, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-3.506557897319982, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-3.2188758248682006`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-2.8134107167600364`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-2.6592600369327783`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-2.5257286443082556`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-2.4079456086518722`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-1.6094379124341003`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-1.203972804325936, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-0.916290731874155, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-0.5108256237659907, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-0.35667494393873245`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-0.2231435513142097, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-0.10536051565782628`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {0.6931471805599453, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {1.0986122886681098`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {1.3862943611198906`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}}}, {Automatic, Automatic}},
  GridLines->{None, None},
  ImageSize->400,
  Method->{},
  PlotRange->{{0.001, 98.001}, {-6.907755278982137, -0.6931471805599453}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], {None, None}},
  Ticks->{Automatic, {{-6.907755278982137, 
      FormBox[
       TagBox[
        InterpretationBox["\"0.001\"", 0.001, AutoDelete -> True], 
        NumberForm[#, {
          DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {-5.298317366548036, 
      FormBox[
       TagBox[
        InterpretationBox["\"0.005\"", 0.005, AutoDelete -> True], 
        NumberForm[#, {
          DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {-4.605170185988092, 
      FormBox[
       TagBox[
        InterpretationBox["\"0.010\"", 0.01, AutoDelete -> True], 
        NumberForm[#, {
          DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {-2.995732273553991, 
      FormBox[
       TagBox[
        InterpretationBox["\"0.050\"", 0.05, AutoDelete -> True], 
        NumberForm[#, {
          DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {-2.302585092994046, 
      FormBox[
       TagBox[
        InterpretationBox["\"0.100\"", 0.1, AutoDelete -> True], 
        NumberForm[#, {
          DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {-0.6931471805599453, 
      FormBox[
       TagBox[
        InterpretationBox["\"0.500\"", 0.5, AutoDelete -> True], 
        NumberForm[#, {
          DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {0., 
      FormBox[
       TagBox[
        InterpretationBox["\"1.000\"", 1., AutoDelete -> True], NumberForm[#, {
          DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {1.6094379124341003`, 
      FormBox[
       TagBox[
        InterpretationBox["\"5.000\"", 5., AutoDelete -> True], NumberForm[#, {
          DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {-6.214608098422191, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-5.809142990314028, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-5.521460917862246, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-5.115995809754082, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-4.961845129926823, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-4.8283137373023015`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-4.710530701645918, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-3.912023005428146, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-3.506557897319982, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-3.2188758248682006`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-2.8134107167600364`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-2.6592600369327783`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-2.5257286443082556`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-2.4079456086518722`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-1.6094379124341003`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-1.203972804325936, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-0.916290731874155, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-0.5108256237659907, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-0.35667494393873245`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-0.2231435513142097, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-0.10536051565782628`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {0.6931471805599453, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {1.0986122886681098`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {1.3862943611198906`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}}}]], "Output",
 CellChangeTimes->{{3.5368345192616243`*^9, 3.5368345396777973`*^9}, 
   3.536834597654714*^9, 3.536834634085017*^9, 3.5368349019419928`*^9, 
   3.536834958549233*^9, 3.5368349904251738`*^9, {3.536835110796332*^9, 
   3.5368351753263397`*^9}, {3.536835220505913*^9, 3.5368352473652287`*^9}, {
   3.536835277861807*^9, 3.53683536946189*^9}, {3.5368354124644938`*^9, 
   3.536835428107284*^9}, {3.536835486082011*^9, 3.5368355244665403`*^9}, {
   3.536835767140502*^9, 3.536835778919826*^9}, 3.536835815930497*^9, {
   3.5368359231343737`*^9, 3.536835952143096*^9}, 3.536835990116393*^9, {
   3.5368360914872913`*^9, 3.536836106525404*^9}, 3.53683625195015*^9, {
   3.536837825727169*^9, 3.536837840610897*^9}, 3.536837904697711*^9},
 ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.537514974043624*^9, 3.53751497570685*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"an", " ", "example", " ", "uniform", " ", "profile"}], ",", " ", 
   RowBox[{
    RowBox[{"0.01", "/", "kb"}], " ", "is", " ", "the", " ", "correct", " ", 
    "answer"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.537515080042609*^9, 3.537515108710931*^9}, {
  3.537515190118761*^9, 3.537515190524118*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"plotRhoLog", "[", 
  RowBox[{
  "\"\<res.txt.pop.L100.d1kb.rho1.0e-5.U.txt.N1.0e5.7624\>\"", ",", "Red", 
   ",", "1"}], "]"}]], "Input",
 CellChangeTimes->{
  3.5368384641000633`*^9, {3.536843752115459*^9, 3.536843752417367*^9}, {
   3.536843820848754*^9, 3.536843836510284*^9}, {3.536843873406966*^9, 
   3.5368438751808367`*^9}, {3.537514959133143*^9, 3.537514959798925*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {RGBColor[1, 0, 0], Thickness[Large], LineBox[CompressedData["
1:eJxdk3lIVFEUh99oidkUM+qYqemYpmWm2Ta55S/X3GfGmVEpLExDigxcBrSw
B+ESLqUN7ZkVUpGkkSU1kY8sggqCoghKgsrMSjLDCitpmXcm3v3jcfn4zu/c
cw88/8Id+mIHjuM2//n+nj/Pf36UWaiNG/rIywOc3IStNyoOeE4bi9MEJ5eM
T3MTVhZcT5U7cGif29xT7kfsjDjDW1XBXDfBO3ww0EmmwPGRH/ouNbE7Tmne
hYy4EHvik6LN95YjsQ+of/OhUtc9nNre38bz8cpcW7CcIw5k6oPs99l4IXIT
K7ZH+xKHMD6U4TB7/7vpmr1ruaVIban06ptBHMH4Zfb5bLyc4RVM/UrGr2K8
BrRvG6+278fGkbg2OjJo8SKOwuqw4SOFMuJoDHzp6JsuU4ocg81jzvfVSQqR
Y7GlOEtlbCJeg3qj22ntDJXIcRjo+WDxee4uvO48dlvNAU8b8xMeTojMA1Et
B80R3irRr8Xp+pLG2ACReYa5eIzWTA1XP6F8POMTGJ+Aey8ifJuLXEWfiKKE
obw7pSLzidj43q97zjj5JPt+bD4J1sfmXtlV8slwHA0Lb3Mgn4z8rc/KMibJ
pyDT4/NBbzn5FPAf+OqOEvLr0HjYmn2yk+5fh5oX5bqmePKp2LCoV15qIZ+K
oJT1Vu8+8mnSej4Nt9c/vVO2gXw6jr16ab4SRT5d+l4uA1WtVZ6VZ8hnYM9k
6f5uNflMaT8+k5k/i9lfFh717mqKcSafjffl+6t+TilFn42GfMu3iQhXYfzP
36/gtBhs150VZCJDC5XxivXSNpF5rX3+fywwzOlQt0PTbY2kvA7tXzdldH5T
inkd3vr9ejAxk/I6VJm7WluLKa9Ha1DHm92BlNdL5+P1MCmNXjc83MW8HvVT
imVpniJzOTi07+buoiCRkYNYmXVhxSyR+RxpvZCDizsrxza5UN6AgbL+y0Ma
yhvgtCh43ncfyhvQPyZvuOBPeQOqjyaem5pNeaO0HkbpvLwR7VGWJddCKW9E
bZ36RJiK8iZpf5iknjdJ5xNMzPtzMTKvIG04nPK50n3wuVhQsUUZsJjyTD2X
x9yfJ90P/59/A/mtrZY=
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->False,
  AxesOrigin->{0.001, -6.907755278982137},
  CoordinatesToolOptions:>{"DisplayFunction" -> ({
      Part[#, 1], 
      Exp[
       Part[#, 2]]}& ), "CopiedValueFunction" -> ({
      Part[#, 1], 
      Exp[
       Part[#, 2]]}& )},
  Frame->True,
  FrameLabel->{{
     FormBox["\"\[Rho] / kb\"", TraditionalForm], None}, {
     FormBox[
      InterpretationBox[
       Cell[
        BoxData[
         FormBox[
          StyleBox["\"locus kb\"", StripOnInput -> False], TraditionalForm]], 
        "Text", "TR"], 
       Text[
        Style["locus kb"]]], TraditionalForm], 
     FormBox[
      InterpretationBox[
       Cell[
        BoxData[
         FormBox[
          StyleBox["\"\"", StripOnInput -> False], TraditionalForm]], "Text", 
        "TR"], 
       Text[
        Style[""]]], TraditionalForm]}},
  FrameStyle->Directive[
    Thickness[0.004], FontSize -> 18],
  FrameTicks->{{{{-6.907755278982137, 
       FormBox[
        TagBox[
         InterpretationBox["\"0.001\"", 0.001, AutoDelete -> True], 
         NumberForm[#, {
           DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {-5.298317366548036, 
       FormBox[
        TagBox[
         InterpretationBox["\"0.005\"", 0.005, AutoDelete -> True], 
         NumberForm[#, {
           DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {-4.605170185988092, 
       FormBox[
        TagBox[
         InterpretationBox["\"0.010\"", 0.01, AutoDelete -> True], 
         NumberForm[#, {
           DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {-2.995732273553991, 
       FormBox[
        TagBox[
         InterpretationBox["\"0.050\"", 0.05, AutoDelete -> True], 
         NumberForm[#, {
           DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {-2.302585092994046, 
       FormBox[
        TagBox[
         InterpretationBox["\"0.100\"", 0.1, AutoDelete -> True], 
         NumberForm[#, {
           DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {-0.6931471805599453, 
       FormBox[
        TagBox[
         InterpretationBox["\"0.500\"", 0.5, AutoDelete -> True], 
         NumberForm[#, {
           DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {0., 
       FormBox[
        TagBox[
         InterpretationBox["\"1.000\"", 1., AutoDelete -> True], 
         NumberForm[#, {
           DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {1.6094379124341003`, 
       FormBox[
        TagBox[
         InterpretationBox["\"5.000\"", 5., AutoDelete -> True], 
         NumberForm[#, {
           DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
        TraditionalForm]}, {-6.214608098422191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-5.809142990314028, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-5.521460917862246, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-5.115995809754082, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-4.961845129926823, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-4.8283137373023015`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-4.710530701645918, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-3.912023005428146, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-3.506557897319982, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-3.2188758248682006`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-2.8134107167600364`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-2.6592600369327783`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-2.5257286443082556`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-2.4079456086518722`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-1.6094379124341003`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-1.203972804325936, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-0.916290731874155, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-0.5108256237659907, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-0.35667494393873245`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-0.2231435513142097, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-0.10536051565782628`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {0.6931471805599453, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {1.0986122886681098`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {1.3862943611198906`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}}, {{-6.907755278982137, 
       FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
       FormBox["\"\"", TraditionalForm]}, {-4.605170185988092, 
       FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
       FormBox["\"\"", TraditionalForm]}, {-2.302585092994046, 
       FormBox["\"\"", TraditionalForm]}, {-0.6931471805599453, 
       FormBox["\"\"", TraditionalForm]}, {0., 
       FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
       FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-5.809142990314028, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-5.521460917862246, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-5.115995809754082, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-4.961845129926823, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-4.8283137373023015`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-4.710530701645918, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-3.912023005428146, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-3.506557897319982, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-3.2188758248682006`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-2.8134107167600364`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-2.6592600369327783`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-2.5257286443082556`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-2.4079456086518722`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-1.6094379124341003`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-1.203972804325936, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-0.916290731874155, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-0.5108256237659907, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-0.35667494393873245`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-0.2231435513142097, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {-0.10536051565782628`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {0.6931471805599453, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {1.0986122886681098`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {1.3862943611198906`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}}}, {Automatic, Automatic}},
  GridLines->{None, None},
  Method->{},
  PlotRange->{{0.001, 98.001}, {-6.907755278982137, -0.6931471805599453}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], {None, None}},
  Ticks->{Automatic, {{-6.907755278982137, 
      FormBox[
       TagBox[
        InterpretationBox["\"0.001\"", 0.001, AutoDelete -> True], 
        NumberForm[#, {
          DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {-5.298317366548036, 
      FormBox[
       TagBox[
        InterpretationBox["\"0.005\"", 0.005, AutoDelete -> True], 
        NumberForm[#, {
          DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {-4.605170185988092, 
      FormBox[
       TagBox[
        InterpretationBox["\"0.010\"", 0.01, AutoDelete -> True], 
        NumberForm[#, {
          DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {-2.995732273553991, 
      FormBox[
       TagBox[
        InterpretationBox["\"0.050\"", 0.05, AutoDelete -> True], 
        NumberForm[#, {
          DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {-2.302585092994046, 
      FormBox[
       TagBox[
        InterpretationBox["\"0.100\"", 0.1, AutoDelete -> True], 
        NumberForm[#, {
          DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {-0.6931471805599453, 
      FormBox[
       TagBox[
        InterpretationBox["\"0.500\"", 0.5, AutoDelete -> True], 
        NumberForm[#, {
          DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {0., 
      FormBox[
       TagBox[
        InterpretationBox["\"1.000\"", 1., AutoDelete -> True], NumberForm[#, {
          DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {1.6094379124341003`, 
      FormBox[
       TagBox[
        InterpretationBox["\"5.000\"", 5., AutoDelete -> True], NumberForm[#, {
          DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
       TraditionalForm]}, {-6.214608098422191, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-5.809142990314028, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-5.521460917862246, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-5.115995809754082, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-4.961845129926823, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-4.8283137373023015`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-4.710530701645918, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-3.912023005428146, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-3.506557897319982, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-3.2188758248682006`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-2.8134107167600364`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-2.6592600369327783`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-2.5257286443082556`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-2.4079456086518722`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-1.6094379124341003`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-1.203972804325936, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-0.916290731874155, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-0.5108256237659907, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-0.35667494393873245`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-0.2231435513142097, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {-0.10536051565782628`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {0.6931471805599453, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {1.0986122886681098`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {1.3862943611198906`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}}}]], "Output",
 CellChangeTimes->{
  3.536838465313463*^9, 3.536843755872027*^9, {3.5368438248176193`*^9, 
   3.536843837235766*^9}, 3.536843875972168*^9, {3.537514938306938*^9, 
   3.537514960669989*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Analysis", "Section",
 CellChangeTimes->{{3.536850574598495*^9, 3.536850575548802*^9}, 
   3.537515038678999*^9}],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.536851254964072*^9, 3.53685125948422*^9}, 
   3.537515038679257*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"listN5", "=", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"loadRho", "[", 
       RowBox[{"dirres", "<>", "#"}], "]"}], "&"}], ",", "inputFilesN5"}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"listN4", "=", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"loadRho", "[", 
       RowBox[{"dirres", "<>", "#"}], "]"}], "&"}], ",", "inputFilesN4"}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"listN3", "=", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"loadRho", "[", 
       RowBox[{"dirres", "<>", "#"}], "]"}], "&"}], ",", "inputFilesN3"}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"listN2", "=", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"loadRho", "[", 
       RowBox[{"dirres", "<>", "#"}], "]"}], "&"}], ",", "inputFilesN2"}], 
    "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.536850657733094*^9, 3.536850704408244*^9}, {
   3.537278358854694*^9, 3.5372783622443743`*^9}, 3.537514996535267*^9, 
   3.537515038680024*^9}],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.53685079537027*^9, 3.536850795774178*^9}, {
  3.537515023402918*^9, 3.537515038681476*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
  "do", " ", "histograms", " ", "of", " ", "means", " ", "rates", " ", "for", 
   " ", "every", " ", "simulation"}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.537515116555854*^9, 3.5375151402057457`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"meansN5", "=", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Mean", "[", 
       RowBox[{"#", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "2"}], "]"}], "]"}], "]"}], "&"}], ",", 
     "listN5"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"meansN4", "=", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Mean", "[", 
       RowBox[{"#", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "2"}], "]"}], "]"}], "]"}], "&"}], ",", 
     "listN4"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"meansN3", "=", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Mean", "[", 
       RowBox[{"#", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "2"}], "]"}], "]"}], "]"}], "&"}], ",", 
     "listN3"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"meansN2", "=", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Mean", "[", 
       RowBox[{"#", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "2"}], "]"}], "]"}], "]"}], "&"}], ",", 
     "listN2"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.536850758273292*^9, 3.536850820758253*^9}, {
  3.537278419614952*^9, 3.537278421706882*^9}, {3.537515017615336*^9, 
  3.537515038682049*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
  "ten", " ", "runs", " ", "for", " ", "every", " ", "rho", " ", "value"}], 
  "*)"}]], "Input",
 CellChangeTimes->{{3.537515433972975*^9, 3.537515451514556*^9}, {
  3.537613900149201*^9, 3.537613901378286*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fN5", "=", 
  RowBox[{"Show", "[", 
   RowBox[{
    RowBox[{"Histogram", "[", 
     RowBox[{"meansN5", ",", 
      RowBox[{"{", 
       RowBox[{"\"\<Log\>\"", ",", "100"}], "}"}], ",", 
      RowBox[{"PlotRange", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "4"}], ",", 
           RowBox[{"-", "0.5"}]}], "}"}], ",", "All"}], "}"}]}], ",", 
      RowBox[{"ChartStyle", "\[Rule]", "Red"}]}], "]"}], ",", 
    RowBox[{"options", "[", 
     RowBox[{"\"\<\[Rho] / kb\>\"", ",", "\"\<counts\>\"", ",", "\"\<\>\""}], 
     "]"}]}], "]"}]}]], "Input"],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
   EdgeForm[Opacity[0.7]], {}, 
   {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
    EdgeForm[Opacity[
    0.7]], {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-79, 25], 0}, {
            Rational[-313, 100], 1}]},
         ImageSizeCache->{{113.11526946107784`, 116.37831479897346`}, {
          58.94637448388535, 84.49199480927317}}]},
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], {}, 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-31, 10], 0}, {
            Rational[-307, 100], 1}]},
         ImageSizeCache->{{118.64136013686908`, 121.90440547476476`}, {
          58.94637448388535, 84.49199480927317}}]},
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-307, 100], 0}, {
            Rational[-76, 25], 2}]},
         ImageSizeCache->{{121.40440547476476`, 124.66745081266038`}, {
          33.90075415849754, 84.49199480927317}}]},
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-76, 25], 0}, {
            Rational[-301, 100], 3}]},
         ImageSizeCache->{{124.16745081266038`, 127.43049615055605`}, {
          8.855133833109733, 84.49199480927317}}]},
       StatusArea[#, 3]& ,
       TagBoxNote->"3"],
      StyleBox["3", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[3, {
        GrayLevel[0]}], "Tooltip"]& ], {}, 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-149, 50], 0}, {
            Rational[-59, 20], 3}]},
         ImageSizeCache->{{129.69354148845167`, 132.9565868263473}, {
          8.855133833109733, 84.49199480927317}}]},
       StatusArea[#, 3]& ,
       TagBoxNote->"3"],
      StyleBox["3", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[3, {
        GrayLevel[0]}], 
      "Tooltip"]& ], {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-52, 25], 0}, {
            Rational[-41, 20], 2}]},
         ImageSizeCache->{{212.58490162532075`, 215.84794696321643`}, {
          33.90075415849754, 84.49199480927317}}]},
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-41, 20], 0}, {
            Rational[-101, 50], 6}]},
         ImageSizeCache->{{215.34794696321643`, 
          218.61099230111205`}, {-66.2817271430537, 84.49199480927317}}]},
       StatusArea[#, 6]& ,
       TagBoxNote->"6"],
      StyleBox["6", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[6, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-101, 50], 0}, {
            Rational[-199, 100], 1}]},
         ImageSizeCache->{{218.11099230111205`, 221.3740376390077}, {
          58.94637448388535, 84.49199480927317}}]},
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-199, 100], 0}, {
            Rational[-49, 25], 1}]},
         ImageSizeCache->{{220.8740376390077, 224.13708297690332`}, {
          58.94637448388535, 84.49199480927317}}]},
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], 
      "Tooltip"]& ], {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-109, 100], 0}, {
            Rational[-53, 50], 7}]},
         ImageSizeCache->{{303.7653977758768, 
          307.0284431137724}, {-91.32734746844153, 84.49199480927317}}]},
       StatusArea[#, 7]& ,
       TagBoxNote->"7"],
      StyleBox["7", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[7, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-53, 50], 0}, {
            Rational[-103, 100], 3}]},
         ImageSizeCache->{{306.5284431137724, 309.7914884516681}, {
          8.855133833109733, 84.49199480927317}}]},
       StatusArea[#, 3]& ,
       TagBoxNote->"3"],
      StyleBox["3", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[3, {
        GrayLevel[0]}], "Tooltip"]& ], {}}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->False,
  AxesOrigin->{-4, 0},
  Frame->True,
  FrameLabel->{{
     FormBox["\"counts\"", TraditionalForm], None}, {
     FormBox[
      InterpretationBox[
       Cell[
        BoxData[
         FormBox[
          StyleBox["\"\[Rho] / kb\"", StripOnInput -> False], 
          TraditionalForm]], "Text", "TR"], 
       Text[
        Style["\[Rho] / kb"]]], TraditionalForm], 
     FormBox[
      InterpretationBox[
       Cell[
        BoxData[
         FormBox[
          StyleBox["\"\"", StripOnInput -> False], TraditionalForm]], "Text", 
        "TR"], 
       Text[
        Style[""]]], TraditionalForm]}},
  FrameStyle->Directive[
    Thickness[0.004], FontSize -> 18],
  FrameTicks->
   FrontEndValueCache[{{Automatic, Automatic}, {
     Histogram`LogTicks, Histogram`LogFrameTicks}}, {{
     Automatic, Automatic}, {{{-3.6989700043360187`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.522878745280338, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.397940008672038, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.3010299956639813`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.221848749616357, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.154901959985743, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.096910013008057, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.0457574905606757`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3., 
        FormBox["0.001`", TraditionalForm], {0.01, 0.}, {
         Thickness[0.001]}}, {-2.6989700043360187`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.522878745280338, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.397940008672038, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.3010299956639813`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.221848749616357, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.154901959985743, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.096910013008057, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.0457574905606757`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2., 
        FormBox["0.01`", TraditionalForm], {0.01, 0.}, {
         Thickness[0.001]}}, {-1.698970004336019, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.5228787452803378`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.397940008672038, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.3010299956639815`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.2218487496163568`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.1549019599857433`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.096910013008057, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.0457574905606755`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1., 
        FormBox["0.1`", TraditionalForm], {0.01, 0.}, {
         Thickness[0.001]}}, {-0.698970004336019, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.5228787452803378, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.39794000867203794`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.3010299956639815, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.2218487496163568, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.1549019599857433, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.0969100130080569, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.04575749056067546, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {0., 
        FormBox["1.`", TraditionalForm], {0.01, 0.}, {
         Thickness[0.001]}}}, {{-3.6989700043360187`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.522878745280338, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.397940008672038, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.3010299956639813`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.221848749616357, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.154901959985743, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.096910013008057, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.0457574905606757`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3., 
        FormBox["\"\"", TraditionalForm], {0.01, 0.}, {
         Thickness[0.001]}}, {-2.6989700043360187`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.522878745280338, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.397940008672038, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.3010299956639813`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.221848749616357, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.154901959985743, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.096910013008057, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.0457574905606757`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2., 
        FormBox["\"\"", TraditionalForm], {0.01, 0.}, {
         Thickness[0.001]}}, {-1.698970004336019, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.5228787452803378`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.397940008672038, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.3010299956639815`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.2218487496163568`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.1549019599857433`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.096910013008057, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.0457574905606755`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1., 
        FormBox["\"\"", TraditionalForm], {0.01, 0.}, {
         Thickness[0.001]}}, {-0.698970004336019, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.5228787452803378, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.39794000867203794`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.3010299956639815, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.2218487496163568, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.1549019599857433, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.0969100130080569, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.04575749056067546, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {0., 
        FormBox["\"\"", TraditionalForm], {0.01, 0.}, {
         Thickness[0.001]}}}}}],
  PlotRange->{{-4, -0.5}, {All, All}},
  PlotRangePadding->{{0, 0}, {
     Scaled[0.02], 
     Scaled[0.1]}},
  Ticks->{Histogram`LogTicks, Automatic}]], "Output",
 CellChangeTimes->{3.537515424672525*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
  "100", " ", "runs", " ", "for", " ", "every", " ", "rho", " ", "value"}], 
  "*)"}]], "Input",
 CellChangeTimes->{{3.537515442804851*^9, 3.537515447698588*^9}, {
  3.537613905557876*^9, 3.537613906474802*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fN5", "=", 
  RowBox[{"Show", "[", 
   RowBox[{
    RowBox[{"Histogram", "[", 
     RowBox[{"meansN5", ",", 
      RowBox[{"{", 
       RowBox[{"\"\<Log\>\"", ",", "100"}], "}"}], ",", 
      RowBox[{"PlotRange", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "4"}], ",", 
           RowBox[{"-", "0.5"}]}], "}"}], ",", "All"}], "}"}]}], ",", 
      RowBox[{"ChartStyle", "\[Rule]", "Red"}]}], "]"}], ",", 
    RowBox[{"options", "[", 
     RowBox[{"\"\<\[Rho] / kb\>\"", ",", "\"\<counts\>\"", ",", "\"\<\>\""}], 
     "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.536850827779476*^9, 3.536850857796267*^9}, {
   3.536851017600573*^9, 3.536851045942011*^9}, {3.536851093726966*^9, 
   3.536851114748364*^9}, {3.536852794388275*^9, 3.536852822887175*^9}, {
   3.537278456747407*^9, 3.5372784610118227`*^9}, 3.537515038690256*^9}],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
   EdgeForm[Opacity[0.7]], {}, 
   {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
    EdgeForm[Opacity[
    0.7]], {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-319, 100], 0}, {
            Rational[-79, 25], 1}]},
         ImageSizeCache->{{117.27352437981182`, 120.45958083832335`}, {
          77.33607419479654, 81.05181538734297}}]},
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-79, 25], 0}, {
            Rational[-313, 100], 3}]},
         ImageSizeCache->{{119.95958083832335`, 123.14563729683493`}, {
          70.90459180970366, 81.05181538734297}}]},
       StatusArea[#, 3]& ,
       TagBoxNote->"3"],
      StyleBox["3", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[3, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-313, 100], 0}, {
            Rational[-31, 10], 8}]},
         ImageSizeCache->{{122.64563729683493`, 125.83169375534646`}, {
          54.82588584697149, 81.05181538734297}}]},
       StatusArea[#, 8]& ,
       TagBoxNote->"8"],
      StyleBox["8", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[8, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-31, 10], 0}, {
            Rational[-307, 100], 10}]},
         ImageSizeCache->{{125.33169375534646`, 128.517750213858}, {
          48.394403461878625`, 81.05181538734297}}]},
       StatusArea[#, 10]& ,
       TagBoxNote->"10"],
      StyleBox["10", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[10, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-307, 100], 0}, {
            Rational[-76, 25], 18}]},
         ImageSizeCache->{{128.017750213858, 131.20380667236952`}, {
          22.668473921507143`, 81.05181538734297}}]},
       StatusArea[#, 18]& ,
       TagBoxNote->"18"],
      StyleBox["18", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[18, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-76, 25], 0}, {
            Rational[-301, 100], 15}]},
         ImageSizeCache->{{130.70380667236952`, 133.8898631308811}, {
          32.315697499146445`, 81.05181538734297}}]},
       StatusArea[#, 15]& ,
       TagBoxNote->"15"],
      StyleBox["15", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[15, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-301, 100], 0}, {
            Rational[-149, 50], 17}]},
         ImageSizeCache->{{133.3898631308811, 136.57591958939264`}, {
          25.884215114053582`, 81.05181538734297}}]},
       StatusArea[#, 17]& ,
       TagBoxNote->"17"],
      StyleBox["17", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[17, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-149, 50], 0}, {
            Rational[-59, 20], 13}]},
         ImageSizeCache->{{136.07591958939264`, 139.26197604790417`}, {
          38.747179884239316`, 81.05181538734297}}]},
       StatusArea[#, 13]& ,
       TagBoxNote->"13"],
      StyleBox["13", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[13, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-59, 20], 0}, {
            Rational[-73, 25], 9}]},
         ImageSizeCache->{{138.76197604790417`, 141.94803250641576`}, {
          51.610144654425056`, 81.05181538734297}}]},
       StatusArea[#, 9]& ,
       TagBoxNote->"9"],
      StyleBox["9", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[9, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-73, 25], 0}, {
            Rational[-289, 100], 3}]},
         ImageSizeCache->{{141.44803250641576`, 144.6340889649273}, {
          70.90459180970366, 81.05181538734297}}]},
       StatusArea[#, 3]& ,
       TagBoxNote->"3"],
      StyleBox["3", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[3, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-289, 100], 0}, {
            Rational[-143, 50], 2}]},
         ImageSizeCache->{{144.1340889649273, 147.32014542343882`}, {
          74.1203330022501, 81.05181538734297}}]},
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-143, 50], 0}, {
            Rational[-283, 100], 1}]},
         ImageSizeCache->{{146.82014542343882`, 150.00620188195037`}, {
          77.33607419479654, 81.05181538734297}}]},
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], 
      "Tooltip"]& ], {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-107, 50], 0}, {
            Rational[-211, 100], 1}]},
         ImageSizeCache->{{211.285500427716, 214.47155688622755`}, {
          77.33607419479654, 81.05181538734297}}]},
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-211, 100], 0}, {
            Rational[-52, 25], 12}]},
         ImageSizeCache->{{213.97155688622755`, 217.15761334473908`}, {
          41.962921076785754`, 81.05181538734297}}]},
       StatusArea[#, 12]& ,
       TagBoxNote->"12"],
      StyleBox["12", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[12, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-52, 25], 0}, {
            Rational[-41, 20], 25}]},
         ImageSizeCache->{{216.65761334473908`, 219.84366980325063`}, {
          0.15828557368210738`, 81.05181538734297}}]},
       StatusArea[#, 25]& ,
       TagBoxNote->"25"],
      StyleBox["25", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[25, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-41, 20], 0}, {
            Rational[-101, 50], 36}]},
         ImageSizeCache->{{219.34366980325063`, 
          222.5297262617622}, {-35.21486754432868, 81.05181538734297}}]},
       StatusArea[#, 36]& ,
       TagBoxNote->"36"],
      StyleBox["36", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[36, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-101, 50], 0}, {
            Rational[-199, 100], 21}]},
         ImageSizeCache->{{222.0297262617622, 225.21578272027372`}, {
          13.021250343867834`, 81.05181538734297}}]},
       StatusArea[#, 21]& ,
       TagBoxNote->"21"],
      StyleBox["21", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[21, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-199, 100], 0}, {
            Rational[-49, 25], 5}]},
         ImageSizeCache->{{224.71578272027372`, 227.90183917878528`}, {
          64.4731094246108, 81.05181538734297}}]},
       StatusArea[#, 5]& ,
       TagBoxNote->"5"],
      StyleBox["5", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[5, {
        GrayLevel[0]}], 
      "Tooltip"]& ], {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-28, 25], 0}, {
            Rational[-109, 100], 2}]},
         ImageSizeCache->{{302.6114200171086, 305.79747647562016`}, {
          74.1203330022501, 81.05181538734297}}]},
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-109, 100], 0}, {
            Rational[-53, 50], 42}]},
         ImageSizeCache->{{305.29747647562016`, 
          308.48353293413174`}, {-54.5093146996073, 81.05181538734297}}]},
       StatusArea[#, 42]& ,
       TagBoxNote->"42"],
      StyleBox["42", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[42, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-53, 50], 0}, {
            Rational[-103, 100], 53}]},
         ImageSizeCache->{{307.98353293413174`, 
          311.1695893926433}, {-89.88246781761808, 81.05181538734297}}]},
       StatusArea[#, 53]& ,
       TagBoxNote->"53"],
      StyleBox["53", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[53, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-103, 100], 0}, {-1, 3}]},
         ImageSizeCache->{{310.6695893926433, 313.8556458511548}, {
          70.90459180970366, 81.05181538734297}}]},
       StatusArea[#, 3]& ,
       TagBoxNote->"3"],
      StyleBox["3", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[3, {
        GrayLevel[0]}], "Tooltip"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->False,
  AxesOrigin->{-4, 0},
  Frame->True,
  FrameLabel->{{
     FormBox["\"counts\"", TraditionalForm], None}, {
     FormBox[
      InterpretationBox[
       Cell[
        BoxData[
         FormBox[
          StyleBox["\"\[Rho] / kb\"", StripOnInput -> False], 
          TraditionalForm]], "Text", "TR"], 
       Text[
        Style["\[Rho] / kb"]]], TraditionalForm], 
     FormBox[
      InterpretationBox[
       Cell[
        BoxData[
         FormBox[
          StyleBox["\"\"", StripOnInput -> False], TraditionalForm]], "Text", 
        "TR"], 
       Text[
        Style[""]]], TraditionalForm]}},
  FrameStyle->Directive[
    Thickness[0.004], FontSize -> 18],
  FrameTicks->
   FrontEndValueCache[{{Automatic, Automatic}, {
     Histogram`LogTicks, Histogram`LogFrameTicks}}, {{
     Automatic, Automatic}, {{{-3.6989700043360187`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.522878745280338, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.397940008672038, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.3010299956639813`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.221848749616357, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.154901959985743, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.096910013008057, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.0457574905606757`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3., 
        FormBox["0.001`", TraditionalForm], {0.01, 0.}, {
         Thickness[0.001]}}, {-2.6989700043360187`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.522878745280338, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.397940008672038, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.3010299956639813`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.221848749616357, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.154901959985743, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.096910013008057, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.0457574905606757`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2., 
        FormBox["0.01`", TraditionalForm], {0.01, 0.}, {
         Thickness[0.001]}}, {-1.698970004336019, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.5228787452803378`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.397940008672038, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.3010299956639815`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.2218487496163568`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.1549019599857433`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.096910013008057, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.0457574905606755`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1., 
        FormBox["0.1`", TraditionalForm], {0.01, 0.}, {
         Thickness[0.001]}}, {-0.698970004336019, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.5228787452803378, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.39794000867203794`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.3010299956639815, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.2218487496163568, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.1549019599857433, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.0969100130080569, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.04575749056067546, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {0., 
        FormBox["1.`", TraditionalForm], {0.01, 0.}, {
         Thickness[0.001]}}}, {{-3.6989700043360187`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.522878745280338, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.397940008672038, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.3010299956639813`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.221848749616357, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.154901959985743, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.096910013008057, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.0457574905606757`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3., 
        FormBox["\"\"", TraditionalForm], {0.01, 0.}, {
         Thickness[0.001]}}, {-2.6989700043360187`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.522878745280338, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.397940008672038, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.3010299956639813`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.221848749616357, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.154901959985743, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.096910013008057, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.0457574905606757`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2., 
        FormBox["\"\"", TraditionalForm], {0.01, 0.}, {
         Thickness[0.001]}}, {-1.698970004336019, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.5228787452803378`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.397940008672038, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.3010299956639815`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.2218487496163568`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.1549019599857433`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.096910013008057, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.0457574905606755`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1., 
        FormBox["\"\"", TraditionalForm], {0.01, 0.}, {
         Thickness[0.001]}}, {-0.698970004336019, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.5228787452803378, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.39794000867203794`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.3010299956639815, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.2218487496163568, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.1549019599857433, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.0969100130080569, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.04575749056067546, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {0., 
        FormBox["\"\"", TraditionalForm], {0.01, 0.}, {
         Thickness[0.001]}}}}}],
  PlotRange->{{-4, -0.5}, {All, All}},
  PlotRangePadding->{{0, 0}, {
     Scaled[0.02], 
     Scaled[0.1]}},
  Ticks->{Histogram`LogTicks, Automatic}]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{{3.5368508472194*^9, 3.536850858431115*^9}, {
   3.536851035742585*^9, 3.536851046487297*^9}, {3.53685109887466*^9, 
   3.536851116345373*^9}, 3.536852823545389*^9, 3.536854018249926*^9, 
   3.537278463340158*^9, 3.537515038705532*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
  "Smaller", " ", "populations", " ", "have", " ", "more", " ", "varience", 
   " ", "but", " ", "the", " ", "infinite", " ", "population", " ", "log", 
   " ", "likelihood", " ", "inference", " ", "does", " ", "still", " ", 
   "well", " ", "for", " ", "the", " ", "crossing", " ", "protocol", " ", 
   "studied"}], " ", "*)"}]], "Input"],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.537515154529202*^9, 3.537515174604412*^9}, 
   3.537515407020586*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fN4", "=", 
  RowBox[{"Show", "[", 
   RowBox[{
    RowBox[{"Histogram", "[", 
     RowBox[{"meansN4", ",", 
      RowBox[{"{", 
       RowBox[{"\"\<Log\>\"", ",", "100"}], "}"}], ",", 
      RowBox[{"PlotRange", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "4"}], ",", 
           RowBox[{"-", "0.5"}]}], "}"}], ",", "All"}], "}"}]}], ",", 
      RowBox[{"ChartStyle", "\[Rule]", "Red"}]}], "]"}], ",", 
    RowBox[{"options", "[", 
     RowBox[{"\"\<\[Rho] / kb\>\"", ",", "\"\<counts\>\"", ",", "\"\<\>\""}], 
     "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.537278470233664*^9, 3.5372784720980263`*^9}, 
   3.537515038833181*^9}],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
   EdgeForm[Opacity[0.7]], {}, 
   {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
    EdgeForm[Opacity[
    0.7]], {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-319, 100], 0}, {
            Rational[-79, 25], 1}]},
         ImageSizeCache->{{117.27352437981176`, 120.45958083832329`}, {
          77.14312972324375, 81.05181538734297}}]},
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-79, 25], 0}, {
            Rational[-313, 100], 3}]},
         ImageSizeCache->{{119.95958083832329`, 123.14563729683482`}, {
          70.32575839504531, 81.05181538734297}}]},
       StatusArea[#, 3]& ,
       TagBoxNote->"3"],
      StyleBox["3", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[3, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-313, 100], 0}, {
            Rational[-31, 10], 10}]},
         ImageSizeCache->{{122.64563729683482`, 125.83169375534635`}, {
          46.46495874635077, 81.05181538734297}}]},
       StatusArea[#, 10]& ,
       TagBoxNote->"10"],
      StyleBox["10", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[10, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-31, 10], 0}, {
            Rational[-307, 100], 8}]},
         ImageSizeCache->{{125.33169375534635`, 128.51775021385794`}, {
          53.28233007454921, 81.05181538734297}}]},
       StatusArea[#, 8]& ,
       TagBoxNote->"8"],
      StyleBox["8", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[8, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-307, 100], 0}, {
            Rational[-76, 25], 19}]},
         ImageSizeCache->{{128.01775021385794`, 131.20380667236947`}, {
          15.786787769457788`, 81.05181538734297}}]},
       StatusArea[#, 19]& ,
       TagBoxNote->"19"],
      StyleBox["19", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[19, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-76, 25], 0}, {
            Rational[-301, 100], 17}]},
         ImageSizeCache->{{130.70380667236947`, 133.88986313088105`}, {
          22.604159097656222`, 81.05181538734297}}]},
       StatusArea[#, 17]& ,
       TagBoxNote->"17"],
      StyleBox["17", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[17, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-301, 100], 0}, {
            Rational[-149, 50], 14}]},
         ImageSizeCache->{{133.38986313088105`, 136.57591958939258`}, {
          32.830216089953886`, 81.05181538734297}}]},
       StatusArea[#, 14]& ,
       TagBoxNote->"14"],
      StyleBox["14", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[14, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-149, 50], 0}, {
            Rational[-59, 20], 16}]},
         ImageSizeCache->{{136.07591958939258`, 139.2619760479041}, {
          26.012844761755446`, 81.05181538734297}}]},
       StatusArea[#, 16]& ,
       TagBoxNote->"16"],
      StyleBox["16", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[16, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-59, 20], 0}, {
            Rational[-73, 25], 5}]},
         ImageSizeCache->{{138.7619760479041, 141.94803250641564`}, {
          63.508387066846865`, 81.05181538734297}}]},
       StatusArea[#, 5]& ,
       TagBoxNote->"5"],
      StyleBox["5", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[5, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-73, 25], 0}, {
            Rational[-289, 100], 4}]},
         ImageSizeCache->{{141.44803250641564`, 144.63408896492717`}, {
          66.91707273094609, 81.05181538734297}}]},
       StatusArea[#, 4]& ,
       TagBoxNote->"4"],
      StyleBox["4", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[4, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-289, 100], 0}, {
            Rational[-143, 50], 2}]},
         ImageSizeCache->{{144.13408896492717`, 147.32014542343876`}, {
          73.73444405914452, 81.05181538734297}}]},
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], {}, 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-283, 100], 0}, {
            Rational[-14, 5], 1}]},
         ImageSizeCache->{{149.5062018819503, 152.69225834046188`}, {
          77.14312972324375, 81.05181538734297}}]},
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], 
      "Tooltip"]& ], {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-217, 100], 0}, {
            Rational[-107, 50], 1}]},
         ImageSizeCache->{{208.59944396920437`, 211.7855004277159}, {
          77.14312972324375, 81.05181538734297}}]},
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-107, 50], 0}, {
            Rational[-211, 100], 3}]},
         ImageSizeCache->{{211.2855004277159, 214.47155688622746`}, {
          70.32575839504531, 81.05181538734297}}]},
       StatusArea[#, 3]& ,
       TagBoxNote->"3"],
      StyleBox["3", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[3, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-211, 100], 0}, {
            Rational[-52, 25], 10}]},
         ImageSizeCache->{{213.97155688622746`, 217.157613344739}, {
          46.46495874635077, 81.05181538734297}}]},
       StatusArea[#, 10]& ,
       TagBoxNote->"10"],
      StyleBox["10", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[10, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-52, 25], 0}, {
            Rational[-41, 20], 35}]},
         ImageSizeCache->{{216.657613344739, 
          219.84366980325058`}, {-38.752182856129735`, 81.05181538734297}}]},
       StatusArea[#, 35]& ,
       TagBoxNote->"35"],
      StyleBox["35", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[35, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-41, 20], 0}, {
            Rational[-101, 50], 27}]},
         ImageSizeCache->{{219.34366980325058`, 
          222.5297262617621}, {-11.482697543335973`, 81.05181538734297}}]},
       StatusArea[#, 27]& ,
       TagBoxNote->"27"],
      StyleBox["27", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[27, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-101, 50], 0}, {
            Rational[-199, 100], 18}]},
         ImageSizeCache->{{222.0297262617621, 225.21578272027364`}, {
          19.195473433557005`, 81.05181538734297}}]},
       StatusArea[#, 18]& ,
       TagBoxNote->"18"],
      StyleBox["18", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[18, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-199, 100], 0}, {
            Rational[-49, 25], 6}]},
         ImageSizeCache->{{224.71578272027364`, 227.9018391787852}, {
          60.09970140274765, 81.05181538734297}}]},
       StatusArea[#, 6]& ,
       TagBoxNote->"6"],
      StyleBox["6", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[6, {
        GrayLevel[0]}], 
      "Tooltip"]& ], {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-109, 100], 0}, {
            Rational[-53, 50], 49}]},
         ImageSizeCache->{{305.2974764756201, 
          308.48353293413163`}, {-86.47378215351881, 81.05181538734297}}]},
       StatusArea[#, 49]& ,
       TagBoxNote->"49"],
      StyleBox["49", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[49, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-53, 50], 0}, {
            Rational[-103, 100], 50}]},
         ImageSizeCache->{{307.98353293413163`, 
          311.16958939264316`}, {-89.88246781761805, 81.05181538734297}}]},
       StatusArea[#, 50]& ,
       TagBoxNote->"50"],
      StyleBox["50", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[50, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-103, 100], 0}, {-1, 1}]},
         ImageSizeCache->{{310.66958939264316`, 313.8556458511547}, {
          77.14312972324375, 81.05181538734297}}]},
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->False,
  AxesOrigin->{-4, 0},
  Frame->True,
  FrameLabel->{{
     FormBox["\"counts\"", TraditionalForm], None}, {
     FormBox[
      InterpretationBox[
       Cell[
        BoxData[
         FormBox[
          StyleBox["\"\[Rho] / kb\"", StripOnInput -> False], 
          TraditionalForm]], "Text", "TR"], 
       Text[
        Style["\[Rho] / kb"]]], TraditionalForm], 
     FormBox[
      InterpretationBox[
       Cell[
        BoxData[
         FormBox[
          StyleBox["\"\"", StripOnInput -> False], TraditionalForm]], "Text", 
        "TR"], 
       Text[
        Style[""]]], TraditionalForm]}},
  FrameStyle->Directive[
    Thickness[0.004], FontSize -> 18],
  FrameTicks->
   FrontEndValueCache[{{Automatic, Automatic}, {
     Histogram`LogTicks, Histogram`LogFrameTicks}}, {{
     Automatic, Automatic}, {{{-3.6989700043360187`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.522878745280338, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.397940008672038, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.3010299956639813`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.221848749616357, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.154901959985743, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.096910013008057, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.0457574905606757`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3., 
        FormBox["0.001`", TraditionalForm], {0.01, 0.}, {
         Thickness[0.001]}}, {-2.6989700043360187`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.522878745280338, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.397940008672038, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.3010299956639813`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.221848749616357, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.154901959985743, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.096910013008057, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.0457574905606757`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2., 
        FormBox["0.01`", TraditionalForm], {0.01, 0.}, {
         Thickness[0.001]}}, {-1.698970004336019, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.5228787452803378`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.397940008672038, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.3010299956639815`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.2218487496163568`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.1549019599857433`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.096910013008057, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.0457574905606755`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1., 
        FormBox["0.1`", TraditionalForm], {0.01, 0.}, {
         Thickness[0.001]}}, {-0.698970004336019, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.5228787452803378, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.39794000867203794`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.3010299956639815, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.2218487496163568, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.1549019599857433, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.0969100130080569, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.04575749056067546, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {0., 
        FormBox["1.`", TraditionalForm], {0.01, 0.}, {
         Thickness[0.001]}}}, {{-3.6989700043360187`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.522878745280338, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.397940008672038, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.3010299956639813`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.221848749616357, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.154901959985743, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.096910013008057, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.0457574905606757`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3., 
        FormBox["\"\"", TraditionalForm], {0.01, 0.}, {
         Thickness[0.001]}}, {-2.6989700043360187`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.522878745280338, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.397940008672038, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.3010299956639813`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.221848749616357, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.154901959985743, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.096910013008057, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.0457574905606757`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2., 
        FormBox["\"\"", TraditionalForm], {0.01, 0.}, {
         Thickness[0.001]}}, {-1.698970004336019, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.5228787452803378`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.397940008672038, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.3010299956639815`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.2218487496163568`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.1549019599857433`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.096910013008057, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.0457574905606755`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1., 
        FormBox["\"\"", TraditionalForm], {0.01, 0.}, {
         Thickness[0.001]}}, {-0.698970004336019, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.5228787452803378, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.39794000867203794`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.3010299956639815, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.2218487496163568, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.1549019599857433, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.0969100130080569, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.04575749056067546, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {0., 
        FormBox["\"\"", TraditionalForm], {0.01, 0.}, {
         Thickness[0.001]}}}}}],
  PlotRange->{{-4, -0.5}, {All, All}},
  PlotRangePadding->{{0, 0}, {
     Scaled[0.02], 
     Scaled[0.1]}},
  Ticks->{Histogram`LogTicks, Automatic}]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{3.537278472733527*^9, 3.53751503884715*^9},
 ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fN3", "=", 
  RowBox[{"Show", "[", 
   RowBox[{
    RowBox[{"Histogram", "[", 
     RowBox[{"meansN3", ",", 
      RowBox[{"{", 
       RowBox[{"\"\<Log\>\"", ",", "100"}], "}"}], ",", 
      RowBox[{"PlotRange", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "4"}], ",", 
           RowBox[{"-", "0.5"}]}], "}"}], ",", "All"}], "}"}]}], ",", 
      RowBox[{"ChartStyle", "\[Rule]", "Red"}]}], "]"}], ",", 
    RowBox[{"options", "[", 
     RowBox[{"\"\<\[Rho] / kb\>\"", ",", "\"\<counts\>\"", ",", "\"\<\>\""}], 
     "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.537278484379486*^9, 3.5372784864177513`*^9}, 
   3.537515038914055*^9}],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
   EdgeForm[Opacity[0.7]], {}, 
   {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
    EdgeForm[Opacity[
    0.7]], {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-13, 4], 0}, {
            Rational[-161, 50], 1}]},
         ImageSizeCache->{{111.90141146278864`, 115.08746792130017`}, {
          77.27423301801679, 81.05181538734296}}]},
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-161, 50], 0}, {
            Rational[-319, 100], 4}]},
         ImageSizeCache->{{114.58746792130017`, 117.77352437981176`}, {
          67.44148591003827, 81.05181538734296}}]},
       StatusArea[#, 4]& ,
       TagBoxNote->"4"],
      StyleBox["4", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[4, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-319, 100], 0}, {
            Rational[-79, 25], 3}]},
         ImageSizeCache->{{117.27352437981176`, 120.45958083832329`}, {
          70.71906827936444, 81.05181538734296}}]},
       StatusArea[#, 3]& ,
       TagBoxNote->"3"],
      StyleBox["3", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[3, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-79, 25], 0}, {
            Rational[-313, 100], 5}]},
         ImageSizeCache->{{119.95958083832329`, 123.14563729683482`}, {
          64.16390354071208, 81.05181538734296}}]},
       StatusArea[#, 5]& ,
       TagBoxNote->"5"],
      StyleBox["5", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[5, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-313, 100], 0}, {
            Rational[-31, 10], 7}]},
         ImageSizeCache->{{122.64563729683482`, 125.83169375534635`}, {
          57.60873880205974, 81.05181538734296}}]},
       StatusArea[#, 7]& ,
       TagBoxNote->"7"],
      StyleBox["7", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[7, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-31, 10], 0}, {
            Rational[-307, 100], 8}]},
         ImageSizeCache->{{125.33169375534635`, 128.51775021385794`}, {
          54.331156432733565`, 81.05181538734296}}]},
       StatusArea[#, 8]& ,
       TagBoxNote->"8"],
      StyleBox["8", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[8, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-307, 100], 0}, {
            Rational[-76, 25], 13}]},
         ImageSizeCache->{{128.01775021385794`, 131.20380667236947`}, {
          37.94324458610269, 81.05181538734296}}]},
       StatusArea[#, 13]& ,
       TagBoxNote->"13"],
      StyleBox["13", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[13, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-76, 25], 0}, {
            Rational[-301, 100], 15}]},
         ImageSizeCache->{{130.70380667236947`, 133.88986313088105`}, {
          31.38807984745035, 81.05181538734296}}]},
       StatusArea[#, 15]& ,
       TagBoxNote->"15"],
      StyleBox["15", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[15, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-301, 100], 0}, {
            Rational[-149, 50], 13}]},
         ImageSizeCache->{{133.38986313088105`, 136.57591958939258`}, {
          37.94324458610269, 81.05181538734296}}]},
       StatusArea[#, 13]& ,
       TagBoxNote->"13"],
      StyleBox["13", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[13, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-149, 50], 0}, {
            Rational[-59, 20], 15}]},
         ImageSizeCache->{{136.07591958939258`, 139.2619760479041}, {
          31.38807984745035, 81.05181538734296}}]},
       StatusArea[#, 15]& ,
       TagBoxNote->"15"],
      StyleBox["15", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[15, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-59, 20], 0}, {
            Rational[-73, 25], 6}]},
         ImageSizeCache->{{138.7619760479041, 141.94803250641564`}, {
          60.886321171385916`, 81.05181538734296}}]},
       StatusArea[#, 6]& ,
       TagBoxNote->"6"],
      StyleBox["6", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[6, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-73, 25], 0}, {
            Rational[-289, 100], 4}]},
         ImageSizeCache->{{141.44803250641564`, 144.63408896492717`}, {
          67.44148591003827, 81.05181538734296}}]},
       StatusArea[#, 4]& ,
       TagBoxNote->"4"],
      StyleBox["4", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[4, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-289, 100], 0}, {
            Rational[-143, 50], 2}]},
         ImageSizeCache->{{144.13408896492717`, 147.32014542343876`}, {
          73.9966506486906, 81.05181538734296}}]},
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-143, 50], 0}, {
            Rational[-283, 100], 2}]},
         ImageSizeCache->{{146.82014542343876`, 150.0062018819503}, {
          73.9966506486906, 81.05181538734296}}]},
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-283, 100], 0}, {
            Rational[-14, 5], 1}]},
         ImageSizeCache->{{149.5062018819503, 152.69225834046188`}, {
          77.27423301801679, 81.05181538734296}}]},
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-14, 5], 0}, {
            Rational[-277, 100], 1}]},
         ImageSizeCache->{{152.19225834046188`, 155.3783147989734}, {
          77.27423301801679, 81.05181538734296}}]},
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], 
      "Tooltip"]& ], {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-217, 100], 0}, {
            Rational[-107, 50], 1}]},
         ImageSizeCache->{{208.59944396920437`, 211.7855004277159}, {
          77.27423301801679, 81.05181538734296}}]},
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-107, 50], 0}, {
            Rational[-211, 100], 6}]},
         ImageSizeCache->{{211.2855004277159, 214.47155688622746`}, {
          60.886321171385916`, 81.05181538734296}}]},
       StatusArea[#, 6]& ,
       TagBoxNote->"6"],
      StyleBox["6", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[6, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-211, 100], 0}, {
            Rational[-52, 25], 9}]},
         ImageSizeCache->{{213.97155688622746`, 217.157613344739}, {
          51.05357406340739, 81.05181538734296}}]},
       StatusArea[#, 9]& ,
       TagBoxNote->"9"],
      StyleBox["9", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[9, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-52, 25], 0}, {
            Rational[-41, 20], 25}]},
         ImageSizeCache->{{216.657613344739, 
          219.84366980325058`}, {-1.3877438458113858`, 81.05181538734296}}]},
       StatusArea[#, 25]& ,
       TagBoxNote->"25"],
      StyleBox["25", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[25, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-41, 20], 0}, {
            Rational[-101, 50], 32}]},
         ImageSizeCache->{{219.34366980325058`, 
          222.5297262617621}, {-24.330820431094608`, 81.05181538734296}}]},
       StatusArea[#, 32]& ,
       TagBoxNote->"32"],
      StyleBox["32", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[32, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-101, 50], 0}, {
            Rational[-199, 100], 24}]},
         ImageSizeCache->{{222.0297262617621, 225.21578272027364`}, {
          1.8898385235147828`, 81.05181538734296}}]},
       StatusArea[#, 24]& ,
       TagBoxNote->"24"],
      StyleBox["24", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[24, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-199, 100], 0}, {
            Rational[-49, 25], 3}]},
         ImageSizeCache->{{224.71578272027364`, 227.9018391787852}, {
          70.71906827936444, 81.05181538734296}}]},
       StatusArea[#, 3]& ,
       TagBoxNote->"3"],
      StyleBox["3", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[3, {
        GrayLevel[0]}], 
      "Tooltip"]& ], {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-28, 25], 0}, {
            Rational[-109, 100], 6}]},
         ImageSizeCache->{{302.6114200171085, 305.7974764756201}, {
          60.886321171385916`, 81.05181538734296}}]},
       StatusArea[#, 6]& ,
       TagBoxNote->"6"],
      StyleBox["6", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[6, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-109, 100], 0}, {
            Rational[-53, 50], 52}]},
         ImageSizeCache->{{305.2974764756201, 
          308.48353293413163`}, {-89.88246781761809, 81.05181538734296}}]},
       StatusArea[#, 52]& ,
       TagBoxNote->"52"],
      StyleBox["52", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[52, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-53, 50], 0}, {
            Rational[-103, 100], 37}]},
         ImageSizeCache->{{307.98353293413163`, 
          311.16958939264316`}, {-40.71873227772548, 81.05181538734296}}]},
       StatusArea[#, 37]& ,
       TagBoxNote->"37"],
      StyleBox["37", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[37, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-103, 100], 0}, {-1, 5}]},
         ImageSizeCache->{{310.66958939264316`, 313.8556458511547}, {
          64.16390354071208, 81.05181538734296}}]},
       StatusArea[#, 5]& ,
       TagBoxNote->"5"],
      StyleBox["5", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[5, {
        GrayLevel[0]}], "Tooltip"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->False,
  AxesOrigin->{-4, 0},
  Frame->True,
  FrameLabel->{{
     FormBox["\"counts\"", TraditionalForm], None}, {
     FormBox[
      InterpretationBox[
       Cell[
        BoxData[
         FormBox[
          StyleBox["\"\[Rho] / kb\"", StripOnInput -> False], 
          TraditionalForm]], "Text", "TR"], 
       Text[
        Style["\[Rho] / kb"]]], TraditionalForm], 
     FormBox[
      InterpretationBox[
       Cell[
        BoxData[
         FormBox[
          StyleBox["\"\"", StripOnInput -> False], TraditionalForm]], "Text", 
        "TR"], 
       Text[
        Style[""]]], TraditionalForm]}},
  FrameStyle->Directive[
    Thickness[0.004], FontSize -> 18],
  FrameTicks->
   FrontEndValueCache[{{Automatic, Automatic}, {
     Histogram`LogTicks, Histogram`LogFrameTicks}}, {{
     Automatic, Automatic}, {{{-3.6989700043360187`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.522878745280338, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.397940008672038, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.3010299956639813`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.221848749616357, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.154901959985743, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.096910013008057, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.0457574905606757`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3., 
        FormBox["0.001`", TraditionalForm], {0.01, 0.}, {
         Thickness[0.001]}}, {-2.6989700043360187`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.522878745280338, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.397940008672038, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.3010299956639813`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.221848749616357, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.154901959985743, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.096910013008057, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.0457574905606757`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2., 
        FormBox["0.01`", TraditionalForm], {0.01, 0.}, {
         Thickness[0.001]}}, {-1.698970004336019, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.5228787452803378`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.397940008672038, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.3010299956639815`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.2218487496163568`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.1549019599857433`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.096910013008057, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.0457574905606755`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1., 
        FormBox["0.1`", TraditionalForm], {0.01, 0.}, {
         Thickness[0.001]}}, {-0.698970004336019, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.5228787452803378, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.39794000867203794`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.3010299956639815, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.2218487496163568, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.1549019599857433, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.0969100130080569, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.04575749056067546, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {0., 
        FormBox["1.`", TraditionalForm], {0.01, 0.}, {
         Thickness[0.001]}}}, {{-3.6989700043360187`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.522878745280338, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.397940008672038, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.3010299956639813`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.221848749616357, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.154901959985743, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.096910013008057, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.0457574905606757`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3., 
        FormBox["\"\"", TraditionalForm], {0.01, 0.}, {
         Thickness[0.001]}}, {-2.6989700043360187`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.522878745280338, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.397940008672038, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.3010299956639813`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.221848749616357, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.154901959985743, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.096910013008057, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.0457574905606757`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2., 
        FormBox["\"\"", TraditionalForm], {0.01, 0.}, {
         Thickness[0.001]}}, {-1.698970004336019, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.5228787452803378`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.397940008672038, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.3010299956639815`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.2218487496163568`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.1549019599857433`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.096910013008057, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.0457574905606755`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1., 
        FormBox["\"\"", TraditionalForm], {0.01, 0.}, {
         Thickness[0.001]}}, {-0.698970004336019, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.5228787452803378, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.39794000867203794`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.3010299956639815, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.2218487496163568, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.1549019599857433, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.0969100130080569, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.04575749056067546, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {0., 
        FormBox["\"\"", TraditionalForm], {0.01, 0.}, {
         Thickness[0.001]}}}}}],
  PlotRange->{{-4, -0.5}, {All, All}},
  PlotRangePadding->{{0, 0}, {
     Scaled[0.02], 
     Scaled[0.1]}},
  Ticks->{Histogram`LogTicks, Automatic}]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{3.5372784872703543`*^9, 3.537515038971734*^9},
 ImageCache->GraphicsData["CompressedBitmap", "\<\
eJztXUvM41YV9vzJP/nnUdSRivpgSgeoqqJOA4uiDqiI34UCqlpcVbwW2Ywq
onaBCG1ZeJsVRgjhnXdeIAuExcJQyCoLIqbyAm+88caLtFK68MILs/Aii8N9
206cxE6cTOYR/Xn81/Y93zn33HPPOb6+983bH777i1/e/vC9d27f+MH7twfv
vvfOBze+/6v3UVHrgiRdeBe9H78htdFvkKTCB369hz9W//4H+WpBPJtCr9cD
042kv+cPtSGNQiBVDkYwB7jCrvCNHnQHDi6S/lS8AiABhYAYQDgXV0TjISpS
wE/FFR+Rr4tg9wlksMMUIE0gjmNI5nDGroTEAxkd1txYeoyVzdlpcZxKv8/X
dgahPQAmBPrudsl33xgjZHCR1wopWD10WB1LZwxI6AwLlypDB/yR2iICbcHA
DhAYH7SeLPEySVZhMktJBVoeyCVIA0vU1DM8IniIPejjsp4JMaFJ0UwdDLqP
BcbQXIPUN8i1suaSSzPGFHDChJQlnk7r1ydAQMwjsAaY4S6MZvMiJNQ2qQ89
VsUkhhMuzdCmtZi+QIQaDLqozAwShqiNeKeIFDOA+dQ+ITK4CFaQAn/xUww/
4bVD6lGF6DtLeFCLGArG0wMvZXjaWdsgiQRzOBVNFoMhS9DVXNFkAtJQh4FM
hT2wwxa7hB/WvVjKao8F0ekcfksh/TOn2fgK008kXsuUSd7wEiGfwMLnDWGG
/ussgOHvrurgVqkGRgGk/gtg5lOHq4AAw5scA7y4cJ49nTMwp0tgDD8l9PJI
UCtlSHgzlSDJN4mc1xyqt5SlrGdFMKRasiSZnulB4KhEP+0gWZSMok0Enone
Y/13iLsKw/Mv1stFR5JUCHBfSELQZKYyKXRYxZ4uowr0XF+7nBHTaZ8M7D75
f2i7EKdzrsZUu09BUvow6MtCjupoytV4xLjDvc7RB6S/kNPkPozChBuwNDAJ
w+OIg3h0AcQcxnofFGSCe4oCMr58mopzNGcMxkBh0pDR//7vKIA7QuQhDLCN
c6aiGXIUlsp0pAt/oFV8zA5NhqhyxcL6KvEONyfAi1VEk6Fo8YUqYqKZMrgx
ME1rw3SkCcnJuncqijNLi2paqIibKayevCKYJzALPbANFbVUcJorngYumEMV
LD9hFZE23DD4HcPv3/B2QUNZFMUF4adxBFFC1FESphRxG0cRxEmadbdc2Ws7
1PejitfepNA/IF9Y96dg9Ji960pE0fURM8BXxDCCja3PhonpWGeNT0fmbk8H
NJ4xC3dx1XF6uAMhUinR09hpfW1EAL+8L1TryZ5XIdspJcuqlU64Q5Gr9lkq
6vfJF7YmEegytdDjGTVUHhuuDC+mjfp5MRjg0zxkGiNXZ8Z1DOQi5E8RJ0Ax
sF0krw3nMCHgvjiFYZcyOIrgVh1kV+siW0FUrkO0vUj0pLzS5/KixlaOmi3F
8HND9Qw0fIVM0J2wNo+nAYSzhMAhh/O+TEfUpLvx4imiG+bOyUk6AVMRsG81
DKwSUbku0VaOKOROLdTKRP1rcTQVEYDwGvMXdcGZzvkwwF1VSTGxN8+lzAe2
LgpT0uIpAkb+nDnACnQvNwerKsnzWiQ7FaWaCL+yoPXcjSPj7qI/iAd6boVF
+IIa+NPsOFeV/OG4gjR3g1OV3nktehVFmQuavER4877ZE/2nvVCWl6O4XNbh
P9nx1mLtsl5FjrtgqUrsvDqxihJMstAiXxEz1ji6EagNpUSCnsBh/VFZlmB2
2E02SnAXLFWJnVcnVlUHAxbulFakuZFAHVh9ZqxLJIja/U52fIkpdDiqoIM7
YKlK7Lw6seoGkVvR0WyeJ5tZhITbc2G41Zzh7rBIjjoonxVPEcNM/pykkmHc
EVZVkue1SK6XKveTPJ12EXU0K3gGw67wckUAl7i0L3RJ0oSLdDamkWDP9BdP
Ef5R7pycq5KSZNCCf7QroErE5OrEOuU1FMSIXNloQlKczH0gr9wgSEO9azDR
ZO4c8JNE27isaMM5DOcpBLYGQ0PPG3jpVh04Z5tIraMkV6PUWVMFE+EHTI+i
ic5cLRPGI5PGWag/RMCTLh3SNjoBKIM5GoOp0lDPQFbkpMI5LQYH0hmMDJ6N
lYlcv9kQjnU0Xq1Ao7PmeiayD9kpcTAGfaiCOhyCYU+Is3zGL0f+wdjSQVVV
GGoGTEKeiik/JrIRmKxp4wyi9K0t6ZTV9d01dV0uOZ+xShSqJPHyLLskn+wg
x6mIpS+Tr5UBfZtqKip9BX9coP98iSv1+sC0tebi6rEWyRc8yS6SGHf4v0dK
ys5Kyi6WlLVLylolZScry07zZZxP6am7irMcU1kdT5SUXT0Yzgbk2cpp1A0B
oUpYmSnVz0sq/1lJ2U9Lyr4qalkCUSUgI8WE5Z/sAOI5UcsiiM0BTYbgO/jX
TXhDkl7Cvx7Dv17Hv67iX8+vpLHZ5c9E/So7+gZGj97oGx+V8F01XsbK+Xel
w+3Fw7R4C0JLNb3E+GyKALuENd0P69ZevHy1+m0OIx62yuFbpVIkstAwrcry
bq45TstqQq4Wl3z7iIXNHYsKwUom6e81rE9N1PRtgmm3Nj+EqDdGNa2HYt5J
zNQ5Xx8GtWi3FNb8bsj44lGK83lqRDNxfoV8lYdW7SMQ4wL+86MX6M1j6N9H
LrSlTv1QaA0IrZWvmdLBOZYcsNLqC2X7FVe5J0Vovn4XNAq28vPvkka9uQ8B
bTDuD5KAyg15JqD2/mVC/nv1+IRA1Ob1vbL+2vH1jQed6+qh9nHxSv57YTVz
b9QV23Gx133AOGtn3XBnzsiZrwlrXsM7ejM/BCwdfXH12NEQ8lJXspZZemt9
M5azsA+12hsLh+sZd42FDanG40OtVDEeRwWb9No3jxj2Uk8tu519WmRls7lb
YmYLz6cucH4DG+YhaAqZBSHRmfCXocsegxGvNffiCZ9vrcR7LO30BUaCzzHK
nuuqNmuAiObtY2NzqRdxNtOlebw15zc0wWoVJ3ZbBvMTlTNm6t1u35HHGt5F
s1xWvp9/L3NZZ8KAciwsviAgVWGx4nyFe5nFOjf/71FFrXkn/fi5zD97ylus
1i3s42WROj2nRC+1gQaGtvikRo1byMfL5lOs6pk/Eo/my7pH58RVvXu7o0/X
HHtLvtx1hmzmOWCNp0IdN99KPV6ebt4rGI9c9RcwZi7ocvR+SDA/XkmkrLhG
xuR+gdTO1OrwkNb0xuOCdIQNd9SQsvuG7YMR/uv9QITo/l8O0cH2TeT+aZP7
h8i+G359UnaPhPlTLDzA7Xa7EqEpXeIPO9JXeUKVeqr7boInWNUYBH0WDrv/
ygnIsixdQZ/0kTjdowtYrMmMSq1D4M1nqvFSS9kjzcjdR4FZV7Hg0zq5zT1i
5Y8HQeySILJvBxJ/lHWe/q9WenKPMEWamC3toIvHMOvnF/cIkwZ6Z2KtMyQe
2n3qJAf/3Bi+pdQXx5cle1S8jmC9zN4e8T1NvjpIGWnAP7DDxZSctD4nt3cz
hIz0bAoxbVemg51sRbwezsEUEmwFPS3NsO0RM19UD68bF3pjsEwTTPS2nAnM
0myNTl3GSyUWWOJtwBYAqZdR2yNL4pHf2AOVrsokiSU2JRksn6xUhQYw/HkN
nTchCSO8qOcMja/BxKTpMqLYE9o/16fQDjNs0BXU8BPKU7IootTtgzV2IQh8
8twzB83WLeSPMvuWWMSU3Q+9Qk7xOCOEvSoJtD36GXx1uMTXySKLgjDJuYdi
eS1kqKlOnkIy9cAydNA0DQxrjNW1YtLsAHyEVh8NlVPRDQhvniGs+dOHU5g2
6qkaMTZDw4FpKqw3HYTwWpLzw+LJ1q7DS2MEJwxPOh1RF8PypS8ezlIgS+Y7
oA40vvgusoV4ROmC4c6kZw4BJLPCKQTuGGzLAsuyYeyF2NU/CAax/mvkQn/R
bMoqeHR9P6opG7sRwbJd58kZOKwMKurdqJcPB/1syUQaeFRDspAc3dowkQVJ
VUCDR2aYkF3xbLGGab0+VA3Pij6E8KA+reg++Y+XuUMZhi4d3a4fFAwTDhp1
imAmpWBWZq63HRHnsxFTDkTTHIEfziBCQ/ks9MHW6bpRyNXOGuhv5TJ5e8s+
45uUBu4tbdZnkBUTfF0XmmpvRXhJK7nBmLoW9OlcJ/KWeyo4fvRM0/Sy4dkG
kzoONCexFyJs7V9VVVGl+LMFA2QGxgHVpsabsUiYNuOpMIBkkeoFNW6YMMxj
CIMAeXIB6hf48xR9hhBi/dV4GBPvj3NIY4jo4CfcFUhdQtgM0v0Rxq4JW9A+
Z1ZTuh4UXbo1M/ONK7NY1TzX3ApMIro68SWBZw5JgjcJSPBKaXw98PJcXOMY
zRKMxL8nZ/DVY+bMd8qcfGSBdAeiQhy6fhGifVhGmM/RH3kjDPizRZbnTac2
KAOHrbd0TbSF3NfBmyE5pzOwBrkEBHlVzd013TsQZNd2SFDCyz7790d0sXih
KFcIo8XXFFQs6OGYwq+T02uUhzbxaXGGqa+ZYNv2CfIvLVSMvUybxI5knbXP
kbOxhidgdHlsX5iEWDpPqJDmO4hVVnj8yhZ/6lBpd3n4W0j5FSZUlq4RtMJJ
2oB5KT8lpI1DVoJ5ALbjtLDIJfxpokZAFibhsM9wVwCjz4ZwpARJnVRgo7BR
z5w5wHcX4GWRh/wpJmqeUsBZ1m7B2pzSVFwxTbiUiivmCRsGT/WkCN41NHDZ
6H2F9dUoN4dIMZmTViuH2HDXzCk4yIrSAkVREG2F3LagKy0KZeFbfPQttt56
vbl6jfstEdiqsrJr8tEpCWww2Lwmnj70hhSfyZSrVvqwIT74UJ6S7X/IG9HG
nwhzMgOz34NxnEsVJi7dyMal973mcQCaIkwjVaXKqcKmG2M2Bh1vK5QbpZCT
AglzAS6xspDsmbKYDxzkhtmq+cCGfB3ucM6R5Egn7PaY348/B8j3V8Ec+dme
UacQhxMwtCFZ6lGjWa2KuT+b/toCZvbUQTYenTGl17NkKr0VRQQLlFa95uQb
PCTTAHwUA7gotuwObAinIY4MIAhD1Gwh+kTmacx2dSnEBluRFdtz+MgZGLqi
A2aWtUfC+0bIUJ86TZFfmKaAvngKcD5P4ZM7H8GdT9JcCnAHStSVcYaKsLAD
k+6Sg1wa4SlboXg0aNfmy+RoEFOo66oYIrVJROpMwhEZJhHZXDoNaFX1lJJn
QPBApbF1e/lK2dh3njK2fE3B2ZiGqOGordu36TZhyEarTLZ4840UydtG/oyW
T4jtIMpTpH583x8UqyARImuau6Ez4DzmwvMdyCEriXQQx3Z4MxtmO2E6MaGP
t1TqI39itrNu3mzg8u1bsYnL7y7vi5e38pfT/6pduDR2fb3JyxZlvHTZ1xZl
u36eT62qrrPzhIuY306kQiKgFruU2CMZMTnbD6h62L4FSTpVgbjE7DY0IZgF
2hvj7FpEH2ftg+OFAZUckiU2RW1E7ONas2G2IPxIbqJIFwaDAfT7ffTusdxP
l2y9ObT/Wy/4JUgulCN5UZxVmOVwld09RG6jaOZUND0ZF+rEsVshwKO4gwWO
RiK21V5R+eosn1urNegErivsRiHyKZwp4d9g1Mk4XCukrEWezsm6LDYDnCBr
YfdypGtGhbWI05lWl1AXVsgMhL6cJ1wzjtuCMk5RxWz/A4lvU0FfVZ9zqkVV
2NF4wrZ4yO13U/XRI6C1llJcstxPM02JXBt0yyU7gojpgWuDm1pk7sKAeOzD
71247J6Q5D3RAPeESI5dkk+y88im2CgAIk7ofMM9r1oU+CxJ7qNh5ym7YzXi
Plz1O1a1pEmpXxP7ceGdOf0oJZm8IbvhIea078dx5QKgtxXTHLMdkmDEQ1jP
CiiAOneMaqHgM2kzp2mLOz1bUmTDN3Eaat6nIRSrOoqcIt5RkYzLmMeiWyo1
6JfyiGTm2WIuJtlda29+aPbgQwzeeAS2qWN/jHYnHJewuQt1Fi3YUpfpkwxZ
Z+4Q53As1typOeW5FgputGYjmtk2JgFEccpzA/vzSCnhRwX7A8NBTuAIHMcB
x3bA5xMK9+KZ8kczQjubfUSFfxmkHo+J1ibzyzzUdqnZfor1JXzLxx2PYTKZ
sPcI1N4g13srOanfWKx/YXS8tcjsQY5vwnfs+I+Cv0b3/Nl7tQ+3vaqC8wHd
9uqmOP+VjaWkrGR7uIe/D/NbuvB/CjDqPQ==\
\>"]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fN2", "=", 
  RowBox[{"Show", "[", 
   RowBox[{
    RowBox[{"Histogram", "[", 
     RowBox[{"meansN2", ",", 
      RowBox[{"{", 
       RowBox[{"\"\<Log\>\"", ",", "100"}], "}"}], ",", 
      RowBox[{"PlotRange", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "4"}], ",", 
           RowBox[{"-", "0.5"}]}], "}"}], ",", "All"}], "}"}]}], ",", 
      RowBox[{"ChartStyle", "\[Rule]", "Red"}]}], "]"}], ",", 
    RowBox[{"options", "[", 
     RowBox[{"\"\<\[Rho] / kb\>\"", ",", "\"\<counts\>\"", ",", "\"\<\>\""}], 
     "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.53727850072293*^9, 3.5372785034250298`*^9}, 
   3.537515038991651*^9}],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
   EdgeForm[Opacity[0.7]], {}, 
   {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
    EdgeForm[Opacity[0.7]], {}, {}, {}, {}, {}, {}, 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-94, 25], 0}, {
            Rational[-93, 25], 2}]},
         ImageSizeCache->{{66.23845166809235, 70.31986027944106}, {
          66.91707273094609, 81.05181538734297}}]},
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], {}, {}, {}, {}, 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-89, 25], 0}, {
            Rational[-88, 25], 1}]},
         ImageSizeCache->{{84.145494724836, 88.2269033361847}, {
          73.73444405914452, 81.05181538734297}}]},
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-88, 25], 0}, {
            Rational[-87, 25], 1}]},
         ImageSizeCache->{{87.7269033361847, 91.80831194753341}, {
          73.73444405914452, 81.05181538734297}}]},
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-87, 25], 0}, {
            Rational[-86, 25], 1}]},
         ImageSizeCache->{{91.30831194753341, 95.38972055888217}, {
          73.73444405914452, 81.05181538734297}}]},
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-86, 25], 0}, {
            Rational[-17, 5], 2}]},
         ImageSizeCache->{{94.88972055888217, 98.97112917023088}, {
          66.91707273094609, 81.05181538734297}}]},
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], {}, {}, 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-83, 25], 0}, {
            Rational[-82, 25], 4}]},
         ImageSizeCache->{{105.63394639292835`, 109.71535500427711`}, {
          53.28233007454921, 81.05181538734297}}]},
       StatusArea[#, 4]& ,
       TagBoxNote->"4"],
      StyleBox["4", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[4, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-82, 25], 0}, {
            Rational[-81, 25], 6}]},
         ImageSizeCache->{{109.21535500427711`, 113.29676361562582`}, {
          39.64758741815233, 81.05181538734297}}]},
       StatusArea[#, 6]& ,
       TagBoxNote->"6"],
      StyleBox["6", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[6, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-81, 25], 0}, {
            Rational[-16, 5], 5}]},
         ImageSizeCache->{{112.79676361562582`, 116.87817222697453`}, {
          46.46495874635077, 81.05181538734297}}]},
       StatusArea[#, 5]& ,
       TagBoxNote->"5"],
      StyleBox["5", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[5, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-16, 5], 0}, {
            Rational[-79, 25], 5}]},
         ImageSizeCache->{{116.37817222697453`, 120.45958083832329`}, {
          46.46495874635077, 81.05181538734297}}]},
       StatusArea[#, 5]& ,
       TagBoxNote->"5"],
      StyleBox["5", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[5, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-79, 25], 0}, {
            Rational[-78, 25], 8}]},
         ImageSizeCache->{{119.95958083832329`, 124.040989449672}, {
          26.012844761755446`, 81.05181538734297}}]},
       StatusArea[#, 8]& ,
       TagBoxNote->"8"],
      StyleBox["8", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[8, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-78, 25], 0}, {
            Rational[-77, 25], 5}]},
         ImageSizeCache->{{123.540989449672, 127.62239806102076`}, {
          46.46495874635077, 81.05181538734297}}]},
       StatusArea[#, 5]& ,
       TagBoxNote->"5"],
      StyleBox["5", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[5, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-77, 25], 0}, {
            Rational[-76, 25], 5}]},
         ImageSizeCache->{{127.12239806102076`, 131.20380667236947`}, {
          46.46495874635077, 81.05181538734297}}]},
       StatusArea[#, 5]& ,
       TagBoxNote->"5"],
      StyleBox["5", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[5, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-76, 25], 0}, {-3, 11}]},
         ImageSizeCache->{{130.70380667236947`, 134.78521528371817`}, {
          5.560730777160131, 81.05181538734297}}]},
       StatusArea[#, 11]& ,
       TagBoxNote->"11"],
      StyleBox["11", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[11, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{-3, 0}, {
            Rational[-74, 25], 12}]},
         ImageSizeCache->{{134.28521528371817`, 
          138.36662389506694`}, {-1.2566405510383163`, 81.05181538734297}}]},
       StatusArea[#, 12]& ,
       TagBoxNote->"12"],
      StyleBox["12", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[12, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-74, 25], 0}, {
            Rational[-73, 25], 8}]},
         ImageSizeCache->{{137.86662389506694`, 141.94803250641564`}, {
          26.012844761755446`, 81.05181538734297}}]},
       StatusArea[#, 8]& ,
       TagBoxNote->"8"],
      StyleBox["8", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[8, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-73, 25], 0}, {
            Rational[-72, 25], 5}]},
         ImageSizeCache->{{141.44803250641564`, 145.5294411177644}, {
          46.46495874635077, 81.05181538734297}}]},
       StatusArea[#, 5]& ,
       TagBoxNote->"5"],
      StyleBox["5", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[5, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-72, 25], 0}, {
            Rational[-71, 25], 6}]},
         ImageSizeCache->{{145.0294411177644, 149.11084972911314`}, {
          39.64758741815233, 81.05181538734297}}]},
       StatusArea[#, 6]& ,
       TagBoxNote->"6"],
      StyleBox["6", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[6, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-71, 25], 0}, {
            Rational[-14, 5], 2}]},
         ImageSizeCache->{{148.61084972911314`, 152.69225834046188`}, {
          66.91707273094609, 81.05181538734297}}]},
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-14, 5], 0}, {
            Rational[-69, 25], 7}]},
         ImageSizeCache->{{152.19225834046188`, 156.2736669518106}, {
          32.830216089953886`, 81.05181538734297}}]},
       StatusArea[#, 7]& ,
       TagBoxNote->"7"],
      StyleBox["7", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[7, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-69, 25], 0}, {
            Rational[-68, 25], 1}]},
         ImageSizeCache->{{155.7736669518106, 159.8550755631593}, {
          73.73444405914452, 81.05181538734297}}]},
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-68, 25], 0}, {
            Rational[-67, 25], 1}]},
         ImageSizeCache->{{159.3550755631593, 163.43648417450802`}, {
          73.73444405914452, 81.05181538734297}}]},
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], {}, 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-66, 25], 0}, {
            Rational[-13, 5], 2}]},
         ImageSizeCache->{{166.51789278585676`, 170.5993013972055}, {
          66.91707273094609, 81.05181538734297}}]},
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], {}, {}, {}, {}, {}, {}, {}, 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-58, 25], 0}, {
            Rational[-57, 25], 3}]},
         ImageSizeCache->{{195.16916167664664`, 199.25057028799537`}, {
          60.09970140274765, 81.05181538734297}}]},
       StatusArea[#, 3]& ,
       TagBoxNote->"3"],
      StyleBox["3", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[3, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-57, 25], 0}, {
            Rational[-56, 25], 3}]},
         ImageSizeCache->{{198.75057028799537`, 202.83197889934405`}, {
          60.09970140274765, 81.05181538734297}}]},
       StatusArea[#, 3]& ,
       TagBoxNote->"3"],
      StyleBox["3", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[3, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-56, 25], 0}, {
            Rational[-11, 5], 2}]},
         ImageSizeCache->{{202.33197889934405`, 206.4133875106928}, {
          66.91707273094609, 81.05181538734297}}]},
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-11, 5], 0}, {
            Rational[-54, 25], 3}]},
         ImageSizeCache->{{205.9133875106928, 209.99479612204152`}, {
          60.09970140274765, 81.05181538734297}}]},
       StatusArea[#, 3]& ,
       TagBoxNote->"3"],
      StyleBox["3", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[3, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-54, 25], 0}, {
            Rational[-53, 25], 10}]},
         ImageSizeCache->{{209.49479612204152`, 213.57620473339026`}, {
          12.378102105358565`, 81.05181538734297}}]},
       StatusArea[#, 10]& ,
       TagBoxNote->"10"],
      StyleBox["10", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[10, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-53, 25], 0}, {
            Rational[-52, 25], 8}]},
         ImageSizeCache->{{213.07620473339026`, 217.157613344739}, {
          26.012844761755446`, 81.05181538734297}}]},
       StatusArea[#, 8]& ,
       TagBoxNote->"8"],
      StyleBox["8", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[8, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-52, 25], 0}, {
            Rational[-51, 25], 20}]},
         ImageSizeCache->{{216.657613344739, 
          220.73902195608773`}, {-55.79561117662584, 81.05181538734297}}]},
       StatusArea[#, 20]& ,
       TagBoxNote->"20"],
      StyleBox["20", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[20, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-51, 25], 0}, {-2, 15}]},
         ImageSizeCache->{{220.23902195608773`, 
          224.32043056743646`}, {-21.70875453563363, 81.05181538734297}}]},
       StatusArea[#, 15]& ,
       TagBoxNote->"15"],
      StyleBox["15", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[15, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{-2, 0}, {
            Rational[-49, 25], 8}]},
         ImageSizeCache->{{223.82043056743646`, 227.9018391787852}, {
          26.012844761755446`, 81.05181538734297}}]},
       StatusArea[#, 8]& ,
       TagBoxNote->"8"],
      StyleBox["8", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[8, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-49, 25], 0}, {
            Rational[-48, 25], 13}]},
         ImageSizeCache->{{227.4018391787852, 
          231.48324779013393`}, {-8.074011879236764, 81.05181538734297}}]},
       StatusArea[#, 13]& ,
       TagBoxNote->"13"],
      StyleBox["13", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[13, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-48, 25], 0}, {
            Rational[-47, 25], 5}]},
         ImageSizeCache->{{230.98324779013393`, 235.06465640148267`}, {
          46.46495874635077, 81.05181538734297}}]},
       StatusArea[#, 5]& ,
       TagBoxNote->"5"],
      StyleBox["5", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[5, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-47, 25], 0}, {
            Rational[-46, 25], 6}]},
         ImageSizeCache->{{234.56465640148267`, 238.64606501283137`}, {
          39.64758741815233, 81.05181538734297}}]},
       StatusArea[#, 6]& ,
       TagBoxNote->"6"],
      StyleBox["6", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[6, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-46, 25], 0}, {
            Rational[-9, 5], 3}]},
         ImageSizeCache->{{238.14606501283137`, 242.2274736241801}, {
          60.09970140274765, 81.05181538734297}}]},
       StatusArea[#, 3]& ,
       TagBoxNote->"3"],
      StyleBox["3", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[3, {
        GrayLevel[0]}], "Tooltip"]& ], {}, {}, {}, {}, 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-41, 25], 0}, {
            Rational[-8, 5], 1}]},
         ImageSizeCache->{{256.05310806957505`, 260.13451668092375`}, {
          73.73444405914452, 81.05181538734297}}]},
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], {}, {}, {}, {}, 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-36, 25], 0}, {
            Rational[-7, 5], 1}]},
         ImageSizeCache->{{273.9601511263187, 278.0415597376674}, {
          73.73444405914452, 81.05181538734297}}]},
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], {}, {}, {}, 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-32, 25], 0}, {
            Rational[-31, 25], 2}]},
         ImageSizeCache->{{288.28578557171363`, 292.36719418306234`}, {
          66.91707273094609, 81.05181538734297}}]},
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-31, 25], 0}, {
            Rational[-6, 5], 2}]},
         ImageSizeCache->{{291.86719418306234`, 295.94860279441104`}, {
          66.91707273094609, 81.05181538734297}}]},
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-6, 5], 0}, {
            Rational[-29, 25], 2}]},
         ImageSizeCache->{{295.44860279441104`, 299.5300114057598}, {
          66.91707273094609, 81.05181538734297}}]},
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-29, 25], 0}, {
            Rational[-28, 25], 17}]},
         ImageSizeCache->{{299.0300114057598, 
          303.1114200171085}, {-35.343497192030526`, 81.05181538734297}}]},
       StatusArea[#, 17]& ,
       TagBoxNote->"17"],
      StyleBox["17", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[17, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-28, 25], 0}, {
            Rational[-27, 25], 23}]},
         ImageSizeCache->{{302.6114200171085, 
          306.6928286284573}, {-76.24772516122115, 81.05181538734297}}]},
       StatusArea[#, 23]& ,
       TagBoxNote->"23"],
      StyleBox["23", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[23, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-27, 25], 0}, {
            Rational[-26, 25], 25}]},
         ImageSizeCache->{{306.1928286284573, 
          310.274237239806}, {-89.88246781761805, 81.05181538734297}}]},
       StatusArea[#, 25]& ,
       TagBoxNote->"25"],
      StyleBox["25", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[25, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-26, 25], 0}, {-1, 19}]},
         ImageSizeCache->{{309.774237239806, 
          313.8556458511547}, {-48.97823984842739, 81.05181538734297}}]},
       StatusArea[#, 19]& ,
       TagBoxNote->"19"],
      StyleBox["19", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[19, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{-1, 0}, {
            Rational[-24, 25], 7}]},
         ImageSizeCache->{{313.3556458511547, 317.43705446250345`}, {
          32.830216089953886`, 81.05181538734297}}]},
       StatusArea[#, 7]& ,
       TagBoxNote->"7"],
      StyleBox["7", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[7, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-24, 25], 0}, {
            Rational[-23, 25], 1}]},
         ImageSizeCache->{{316.93705446250345`, 321.01846307385216`}, {
          73.73444405914452, 81.05181538734297}}]},
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], {}, 
    TagBox[
     TooltipBox[
      TagBox[
       {RGBColor[1, 0, 0], 
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{
            Rational[-22, 25], 0}, {
            Rational[-21, 25], 1}]},
         ImageSizeCache->{{324.0998716852009, 328.18128029654963`}, {
          73.73444405914452, 81.05181538734297}}]},
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], 
      "Tooltip"]& ], {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->False,
  AxesOrigin->{-4, 0},
  Frame->True,
  FrameLabel->{{
     FormBox["\"counts\"", TraditionalForm], None}, {
     FormBox[
      InterpretationBox[
       Cell[
        BoxData[
         FormBox[
          StyleBox["\"\[Rho] / kb\"", StripOnInput -> False], 
          TraditionalForm]], "Text", "TR"], 
       Text[
        Style["\[Rho] / kb"]]], TraditionalForm], 
     FormBox[
      InterpretationBox[
       Cell[
        BoxData[
         FormBox[
          StyleBox["\"\"", StripOnInput -> False], TraditionalForm]], "Text", 
        "TR"], 
       Text[
        Style[""]]], TraditionalForm]}},
  FrameStyle->Directive[
    Thickness[0.004], FontSize -> 18],
  FrameTicks->
   FrontEndValueCache[{{Automatic, Automatic}, {
     Histogram`LogTicks, Histogram`LogFrameTicks}}, {{
     Automatic, Automatic}, {{{-3.6989700043360187`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.522878745280338, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.397940008672038, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.3010299956639813`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.221848749616357, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.154901959985743, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.096910013008057, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.0457574905606757`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3., 
        FormBox["0.001`", TraditionalForm], {0.01, 0.}, {
         Thickness[0.001]}}, {-2.6989700043360187`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.522878745280338, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.397940008672038, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.3010299956639813`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.221848749616357, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.154901959985743, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.096910013008057, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.0457574905606757`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2., 
        FormBox["0.01`", TraditionalForm], {0.01, 0.}, {
         Thickness[0.001]}}, {-1.698970004336019, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.5228787452803378`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.397940008672038, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.3010299956639815`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.2218487496163568`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.1549019599857433`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.096910013008057, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.0457574905606755`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1., 
        FormBox["0.1`", TraditionalForm], {0.01, 0.}, {
         Thickness[0.001]}}, {-0.698970004336019, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.5228787452803378, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.39794000867203794`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.3010299956639815, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.2218487496163568, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.1549019599857433, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.0969100130080569, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.04575749056067546, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {0., 
        FormBox["1.`", TraditionalForm], {0.01, 0.}, {
         Thickness[0.001]}}}, {{-3.6989700043360187`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.522878745280338, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.397940008672038, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.3010299956639813`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.221848749616357, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.154901959985743, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.096910013008057, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3.0457574905606757`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-3., 
        FormBox["\"\"", TraditionalForm], {0.01, 0.}, {
         Thickness[0.001]}}, {-2.6989700043360187`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.522878745280338, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.397940008672038, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.3010299956639813`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.221848749616357, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.154901959985743, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.096910013008057, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2.0457574905606757`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-2., 
        FormBox["\"\"", TraditionalForm], {0.01, 0.}, {
         Thickness[0.001]}}, {-1.698970004336019, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.5228787452803378`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.397940008672038, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.3010299956639815`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.2218487496163568`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.1549019599857433`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.096910013008057, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1.0457574905606755`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-1., 
        FormBox["\"\"", TraditionalForm], {0.01, 0.}, {
         Thickness[0.001]}}, {-0.698970004336019, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.5228787452803378, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.39794000867203794`, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.3010299956639815, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.2218487496163568, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.1549019599857433, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.0969100130080569, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {-0.04575749056067546, 
        FormBox["\"\"", TraditionalForm], {0.005, 0.}, {
         Thickness[0.001]}}, {0., 
        FormBox["\"\"", TraditionalForm], {0.01, 0.}, {
         Thickness[0.001]}}}}}],
  PlotRange->{{-4, -0.5}, {All, All}},
  PlotRangePadding->{{0, 0}, {
     Scaled[0.02], 
     Scaled[0.1]}},
  Ticks->{Histogram`LogTicks, Automatic}]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{3.5372785042599907`*^9, 3.537515039052017*^9}]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.537515325065896*^9, 3.5375153922530327`*^9}, 
   3.537515507314803*^9}]
}, Open  ]]
},
AutoGeneratedPackage->None,
WindowSize->{962, 533},
WindowMargins->{{113, Automatic}, {Automatic, 39}},
ShowSelection->True,
FrontEndVersion->"7.0 for Mac OS X x86 (32-bit) (February 18, 2009)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 89, 1, 67, "Section"],
Cell[659, 25, 279, 7, 27, "Input"],
Cell[941, 34, 166, 3, 27, "Input"],
Cell[1110, 39, 165, 3, 27, "Input"],
Cell[1278, 44, 968, 26, 43, "Input"],
Cell[2249, 72, 909, 24, 73, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3195, 101, 116, 2, 67, "Section",
 InitializationCell->True],
Cell[3314, 105, 1178, 31, 73, "Input",
 InitializationCell->True],
Cell[4495, 138, 4424, 112, 223, "Input",
 InitializationCell->True],
Cell[8922, 252, 375, 12, 27, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[9334, 269, 90, 1, 37, "Section"],
Cell[CellGroupData[{
Cell[9449, 274, 1105, 23, 43, "Input"],
Cell[10557, 299, 26446, 505, 293, 14366, 307, "CachedBoxData", "BoxData", \
"Output"]
}, Open  ]],
Cell[37018, 807, 91, 1, 27, "Input"],
Cell[37112, 810, 369, 8, 27, "Input"],
Cell[CellGroupData[{
Cell[37506, 822, 402, 8, 27, "Input"],
Cell[37911, 832, 14739, 313, 269, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[52699, 1151, 119, 2, 67, "Section"],
Cell[52821, 1155, 117, 2, 27, "Input"],
Cell[52941, 1159, 1068, 35, 73, "Input"],
Cell[54012, 1196, 140, 2, 27, "Input"],
Cell[54155, 1200, 253, 5, 27, "Input"],
Cell[54411, 1207, 1278, 43, 73, "Input"],
Cell[55692, 1252, 257, 6, 27, "Input"],
Cell[CellGroupData[{
Cell[55974, 1262, 640, 18, 43, "Input"],
Cell[56617, 1282, 17221, 444, 299, "Output"]
}, Open  ]],
Cell[73853, 1729, 257, 6, 27, "Input"],
Cell[CellGroupData[{
Cell[74135, 1739, 926, 22, 43, "Input"],
Cell[75064, 1763, 25270, 701, 294, "Output"]
}, Open  ]],
Cell[100349, 2467, 380, 7, 43, "Input"],
Cell[100732, 2476, 118, 2, 27, "Input"],
Cell[CellGroupData[{
Cell[100875, 2482, 734, 20, 43, "Input"],
Cell[101612, 2504, 31395, 803, 294, 24969, 695, "CachedBoxData", "BoxData", \
"Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[133044, 3312, 734, 20, 43, "Input"],
Cell[133781, 3334, 34904, 918, 294, 28471, 810, "CachedBoxData", "BoxData", \
"Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[168722, 4257, 733, 20, 43, "Input"],
Cell[169458, 4279, 42383, 1264, 294, "Output"]
}, Open  ]],
Cell[211856, 5546, 120, 2, 27, "Input"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
